<?php
/**
 *    @version 2.1.1 Build 21106 Alpha [ Drury ]
 *    @package hwdVideoShare
 *    @copyright (C) 2007 - 2009 Highwood Design
 *    @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 ***
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

class hwdvids_BE_maintenance
{
   /**
	* system cleanup
	*/
	function maintenance($option)
	{
		global $database, $mainframe, $limit, $limitstart;
  		$db =& JFactory::getDBO();

		$db->SetQuery( "SELECT count(*)"
							. "\nFROM #__hwdvidsvideos AS a"
							. "\nWHERE a.approved = \"deleted\""
							);
		$total = $db->loadResult();
		echo $db->getErrorMsg();

		$permdelete_report = null;
		$fixerrors_report = null;
		$recount_report = null;
		$archivelogs_report = null;

		// set fixerror cache variables
		$cachedir = HWDVS_ADMIN_PATH.'/maintenance/cache/'; // Directory to cache files in (keep outside web root)
		$cacheext = 'cache'; // Extension to give cached files (usually cache, htm, txt)
		$page = 'http://fixerrorfile'; // Requested page
		$cachefile = $cachedir . md5($page) . '.' . $cacheext; // Cache file to either load or create
		$fixerror_cache = (@file_exists($cachefile)) ? @date ("F d Y H:i:s.", filemtime($cachefile)) : "Never";

		// set recount cache variables
		$cachedir = HWDVS_ADMIN_PATH.'/maintenance/cache/'; // Directory to cache files in (keep outside web root)
		$cacheext = 'cache'; // Extension to give cached files (usually cache, htm, txt)
		$page = 'http://recountfile'; // Requested page
		$cachefile = $cachedir . md5($page) . '.' . $cacheext; // Cache file to either load or create
		$recount_cache = (@file_exists($cachefile)) ? @date ("F d Y H:i:s.", filemtime($cachefile)) : "Never";

		// set archive cache variables
		$cachedir = HWDVS_ADMIN_PATH.'/maintenance/cache/'; // Directory to cache files in (keep outside web root)
		$cacheext = 'cache'; // Extension to give cached files (usually cache, htm, txt)
		$page = 'http://archivefile'; // Requested page
		$cachefile = $cachedir . md5($page) . '.' . $cacheext; // Cache file to either load or create
		$archive_cache = (@file_exists($cachefile)) ? @date ("F d Y H:i:s.", filemtime($cachefile)) : "Never";

		hwdvids_HTML::maintenance($option, $permdelete_report, $total, $fixerrors_report, $recount_report, $archivelogs_report, $fixerror_cache, $recount_cache, $archive_cache);
	}
   /**
	* system cleanup
	*/
	function runmaintenance($option)
	{
		global $database, $mainframe, $limit, $limitstart;
  		$db =& JFactory::getDBO();

		$run_permdel = JRequest::getInt( 'run_permdel', 0 );
		$run_fixerrors = JRequest::getInt( 'run_fixerrors', 0 );
		$run_recount = JRequest::getInt( 'run_recount', 0 );
		$run_archivelogs = JRequest::getInt( 'run_archivelogs', 0 );

		$permdelete_report = null;
		$fixerrors_report = null;
		$recount_report = null;
		$archivelogs_report = null;

		if ($run_permdel == 1) {
			// permenantly delete
			$query = "SELECT a.*"
					. "\nFROM #__hwdvidsvideos AS a"
					. "\nWHERE a.approved = \"deleted\""
								;
			$db->SetQuery( $query );
			$rows = $db->loadObjectList();

			for($i=0, $n=count( $rows ); $i < $n; $i++) {
				$row = &$rows[$i];
					$path_flv = JPATH_SITE."/hwdvideos/uploads/".$row->video_id.".flv";
					$path_thumb = JPATH_SITE."/hwdvideos/thumbs/".$row->video_id.".jpg";
					if (@file_exists("$path_flv")) {
							@unlink("$path_flv");
					}
					if (@file_exists("$path_thumb")) {
							@unlink("$path_thumb");
					}
			}

			$db->SetQuery("DELETE FROM #__hwdvidsvideos WHERE approved = \"deleted\"");
			$db->Query();
			if ( !$db->query() ) {
				echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
				exit();
			}
			$permdelete_report = true;
		}

		if ($run_fixerrors !== 0) {
			// perform 'fix errors' maintenance
			require_once(HWDVS_ADMIN_PATH.'/maintenance/fixerrors.class.php');
			$fixerrors_report = hwd_vs_fixerrors::initiate($run_fixerrors);
		}

		if ($run_recount !== 0) {
			// perform 'recount' maintenance
			require_once(HWDVS_ADMIN_PATH.'/maintenance/recount.class.php');
			$recount_report = hwd_vs_recount::initiate($run_recount);
		}

		if ($run_archivelogs !== 0) {
			// perform 'archivelogs' maintenance
			require_once(HWDVS_ADMIN_PATH.'/maintenance/archivelogs.class.php');
			$archivelogs_report = hwd_vs_logs::initiate($run_archivelogs);
		}

		// set fixerror cache variables
		$cachedir = HWDVS_ADMIN_PATH.'/maintenance/cache/'; // Directory to cache files in (keep outside web root)
		$cacheext = 'cache'; // Extension to give cached files (usually cache, htm, txt)
		$page = 'http://fixerrorfile'; // Requested page
		$cachefile = $cachedir . md5($page) . '.' . $cacheext; // Cache file to either load or create
		$fixerror_cache = (@file_exists($cachefile)) ? @date ("F d Y H:i:s.", filemtime($cachefile)) : "Never";

		// set recount cache variables
		$cachedir = HWDVS_ADMIN_PATH.'/maintenance/cache/'; // Directory to cache files in (keep outside web root)
		$cacheext = 'cache'; // Extension to give cached files (usually cache, htm, txt)
		$page = 'http://recountfile'; // Requested page
		$cachefile = $cachedir . md5($page) . '.' . $cacheext; // Cache file to either load or create
		$recount_cache = (@file_exists($cachefile)) ? @date ("F d Y H:i:s.", filemtime($cachefile)) : "Never";

		// set archive cache variables
		$cachedir = HWDVS_ADMIN_PATH.'/maintenance/cache/'; // Directory to cache files in (keep outside web root)
		$cacheext = 'cache'; // Extension to give cached files (usually cache, htm, txt)
		$page = 'http://archivefile'; // Requested page
		$cachefile = $cachedir . md5($page) . '.' . $cacheext; // Cache file to either load or create
		$archive_cache = (@file_exists($cachefile)) ? @date ("F d Y H:i:s.", filemtime($cachefile)) : "Never";

		$db->SetQuery( "SELECT count(*)"
							. "\nFROM #__hwdvidsvideos AS a"
							. "\nWHERE a.approved = \"deleted\""
							);
		$total = $db->loadResult();
		echo $db->getErrorMsg();

		hwdvids_HTML::maintenance($option, $permdelete_report, $total, $fixerrors_report, $recount_report, $archivelogs_report, $fixerror_cache, $recount_cache, $archive_cache);
	}
   /**
	* system cleanup
	*/
	function clearCache($option)
	{
		// set cache variables
		$cachedir = HWDVIDSPATH.'/xml/cache/'; // Directory to cache files in (keep outside web root)
		$cacheext = 'cache'; // Extension to give cached files (usually cache, htm, txt)

		$page_today = 'http://xmlplaylists_today';
		$cachefile_today = $cachedir . md5($page_today) . '.' . $cacheext;

		$page_thisweek = 'http://xmlplaylists_thisweek';
		$cachefile_thisweek = $cachedir . md5($page_thisweek) . '.' . $cacheext;

		$page_thismonth = 'http://xmlplaylists_thismonth';
		$cachefile_thismonth = $cachedir . md5($page_thismonth) . '.' . $cacheext;

		$page_alltime = 'http://xmlplaylists_alltime';
		$cachefile_alltime = $cachedir . md5($page_alltime) . '.' . $cacheext;

		if (file_exists($cachefile_today)) { unlink($cachefile_today); }
		if (file_exists($cachefile_thisweek)) { unlink($cachefile_thisweek); }
		if (file_exists($cachefile_thismonth)) { unlink($cachefile_thismonth); }
		if (file_exists($cachefile_alltime)) { unlink($cachefile_alltime); }

		echo "Cache Successfully Cleared";
		exit;
	}
}
?>