<?php
/**
 *    @version 2.1.1 Build 21106 Alpha [ Drury ]
 *    @package hwdVideoShare
 *    @copyright (C) 2007 - 2009 Highwood Design
 *    @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 ***
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

/**
 * This class is the HTML generator for hwdVideoShare frontend
 *
 * @package    hwdVideoShare
 * @author     Dave Horsfall <info@highwooddesign.co.uk>
 * @copyright  2008 Highwood Design
 * @license    http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @version    1.1.4 Alpha RC2.13
 */

class hwd_vs_core
{
    /**
     * Check video player access and cache settings and query SQL for video data
     *
     * @param string $option  the joomla component name
     * @return       Nothing
     */
    function viewvideo($option)
    {
        global $mosConfig_allowUserRegistration, $limitstart;
		$c = hwd_vs_Config::get_instance();
		$db = & JFactory::getDBO();
		$my = & JFactory::getUser();
		$acl= & JFactory::getACL();

		// check component access settings and deny those without privileges
		if ($c->access_method == 0) {
			if (!hwd_vs_access::allowAccess( $c->gtree_plyr, $c->gtree_plyr_child, hwd_vs_access::userGID( $my->id ))) {
				if ( ($my->id < 1) && (!$mosConfig_allowUserRegistration == '0' && hwd_vs_access::allowAccess( $c->gtree_core, 'RECURSE', $acl->get_group_id('Registered','ARO') ) ) ) {
					hwd_vs_tools::infomessage(1, 0, _HWDVIDS_TITLE_NOACCESS, _HWDVIDS_ALERT_REGISTERFORPLYR, "exclamation.png", 1);
					return;
				} else {
					hwd_vs_tools::infomessage(1, 0, _HWDVIDS_TITLE_NOACCESS. _HWDVIDS_ALERT_PLYR_NOT_AUTHORIZED, "exclamation.png", 1);
					return;
				}
			}
		} else if ($c->access_method == 1) {
			if (!hwd_vs_access::allowLevelAccess( $c->accesslevel_plyr, hwd_vs_access::userGID( $my->id ))) {
				hwd_vs_tools::infomessage(1, 0,  _HWDVIDS_TITLE_NOACCESS, _HWDVIDS_ALERT_NOT_AUTHORIZED, "exclamation.png", 0);
				return;
			}
		}

        // don't want to cache
        header("Cache-Control: no-cache, must-revalidate"); // HTTP/1.1
        header("Expires: Mon, 26 Jul 1997 05:00:00 GMT"); // Date in the past
        // get video id from POST array
        $vid = JRequest::getInt( 'video_id', 0 );
        // check video can be viewed by user
        $where = ' WHERE published = 1';
        $where .= ' AND id = '.(int)$vid;
        $where .= ' AND approved = "yes"';
        if (!$my->id) {
        $where .= ' AND public_private = "public"';
        }
        // check video exists
        $db->SetQuery( 'SELECT count(*)'
                        . ' FROM #__hwdvidsvideos'
                        . $where
                            );
        $videxists = $db->loadResult();

        echo $db->getErrorMsg();
        // if video doesn't exist - tell user
        if ( $videxists<1 ) {
        	hwd_vs_tools::infomessage(1, 0, _HWDVIDS_TITLE_NOACCESS, _HWDVIDS_ALERT_VIDNOEXIST, "exclamation.png", 0);
            return;
        }
        // get view count
        hwd_vs_tools::logViewing($vid);
		include(HWDVIDSPATH.'/../../administrator/components/com_hwdvideoshare/maintenance/recount.class.php');
        hwd_vs_recount::recountVideoViews($vid);

        $join = ' LEFT JOIN #__users AS u ON u.id = a.user_id';
        $select = ' a.*, u.name, u.username';
        if ($c->cbint == 2) {
        	$join.= ' LEFT JOIN #__community_users AS p ON p.userid = a.user_id';
        	$select.= ', p.avatar';
        } else if ($c->cbint == 1) {
        	$join.= ' LEFT JOIN #__comprofiler AS p ON p.id = a.user_id';
        	$select.= ', p.avatar';
        }

        // get video details
        $query1 = 'SELECT'.$select
                	. ' FROM #__hwdvidsvideos AS a'
					. $join
                    . ' WHERE a.id = '.(int)$vid
                    ;

        $db->SetQuery( $query1 );
        $row = $db->loadObject();

        // get videos
        $query = 'SELECT'.$select
                . ' FROM #__hwdvidsvideos AS a'
				. $join
                . ' WHERE a.user_id = '.$row->user_id
                . ' AND a.published = 1'
                . ' AND a.approved = "yes"'
                . ' AND a.id <> '.$row->id
                . ' ORDER BY a.date_uploaded DESC'
                . ' LIMIT 0, '.$c->mbtu_no
                ;
        $db->SetQuery($query);
        $userrows = $db->loadObjectList();

		// get matching video data
        $searchterm = addslashes($row->title." ".$row->description." ".$row->tags);
        if (!$my->id) {
        $wherevids = ' WHERE a.public_private = \'public\' AND a.id <> '.$row->id.' AND MATCH (title,tags,description) AGAINST (\''.$searchterm.'\')';
        } else {
        $wherevids = ' WHERE a.id <> '.$row->id.' AND MATCH (title,tags,description) AGAINST (\''.$searchterm.'\')';
        }
        // get matching video data
        $query = 'SELECT'.$select
                . ' FROM #__hwdvidsvideos AS a'
				. $join
                . $wherevids
                . 'LIMIT 0, '.$c->revi_no
                ;
        $db->SetQuery($query);
        $related_videos = $db->loadObjectList();

        // send out
        hwd_vs_html::viewVideo($option, $row, $userrows, $related_videos);
    }
    /**
     * Query SQL for all accessible category data
     *
     * @param string $option  the joomla component name
     * @return       Nothing
     */
    function categories($option)
    {
        global $mainframe, $limitstart;
		$c = hwd_vs_Config::get_instance();
		$db = & JFactory::getDBO();
		$my = & JFactory::getUser();

		// get category list
        $query = 'SELECT *'
                . ' FROM #__hwdvidscategories'
                . ' WHERE published = 1'
                . ' AND parent = 0'
    			. ' ORDER BY ordering, category_name'
    			;
        $db->setQuery( $query );
        $rows = $db->loadObjectList();

 		// send out
        hwd_vs_html::categories($option, $rows);
    }
    /**
     * Query SQL for requested category data
     *
     * @param string $option  the joomla component name
     * @return       Nothing
     */
    function viewcategory($option)
    {
        global $mainframe, $limitstart, $mosConfig_allowUserRegistration;
		$c = hwd_vs_Config::get_instance();
		$db = & JFactory::getDBO();
		$my = & JFactory::getUser();
		$acl= & JFactory::getACL();

        // number of videos to display
        $limit     = intval($c->vpp);

        // get POST array values
        $cat_id = JRequest::getInt( 'cat_id', 0 );

        // filter for sql data
        $where = ' WHERE a.published = 1';
        $where .= ' AND a.approved = "yes"';
        $where .= ' AND a.category_id = '.$cat_id;
        if (!$my->id) {
        $where .= ' AND a.public_private = "public"';
        }

        $join = ' LEFT JOIN #__users AS u ON u.id = a.user_id';
        $select = ' a.*, u.name, u.username';
        if ($c->cbint == 2) {
        	$join.= ' LEFT JOIN #__community_users AS p ON p.userid = a.user_id';
        	$select.= ', p.avatar';
        } else if ($c->cbint == 1) {
        	$join.= ' LEFT JOIN #__comprofiler AS p ON p.id = a.user_id';
        	$select.= ', p.avatar';
        }

        // count filtered videos
        $db->SetQuery( 'SELECT count(*)'
                            . ' FROM #__hwdvidsvideos AS a'
                            . $where
                            );
        $total = $db->loadResult();
        echo $db->getErrorMsg();

        // pagination
        $pageNav = new mosPageNav( $total, $limitstart, $limit );

        // get filtered video data
        $query = 'SELECT'.$select
                . ' FROM #__hwdvidsvideos AS a'
				. $join
                . $where
                . ' ORDER BY a.date_uploaded DESC'
                ;
        $db->SetQuery($query, $pageNav->limitstart, $pageNav->limit);
        $rows = $db->loadObjectList();

        // get category name
        $query_cat = 'SELECT *'
                            . ' FROM #__hwdvidscategories'
                            . ' WHERE id = '.$cat_id;
        $db->SetQuery( $query_cat );
        $cat = $db->loadObject();

		if (count($cat) == 0) {
			hwd_vs_tools::infomessage(1, 0,  _HWDVIDS_TITLE_NOACCESS, _HWDVIDS_TCDNE, "exclamation.png", 0);
			return;
		}

		// check component access settings and deny those without privileges
		if ($c->access_method == 0) {
			if (!hwd_vs_access::allowAccess( $cat->access_v, $cat->access_v_r, hwd_vs_access::userGID( $my->id ))) {
				if ( ($my->id < 1) && (!$mosConfig_allowUserRegistration == '0' && hwd_vs_access::allowAccess( $c->gtree_core, 'RECURSE', $acl->get_group_id('Registered','ARO') ) ) ) {
					hwd_vs_tools::infomessage(2, 0,  _HWDVIDS_TITLE_NOACCESS, _HWDVIDS_ALERT_REGISTERFORCAT, "exclamation.png", 0);
					return;
				} else {
					hwd_vs_tools::infomessage(2, 0,  _HWDVIDS_TITLE_NOACCESS, _HWDVIDS_ALERT_CAT_NOT_AUTHORIZED, "exclamation.png", 0);
					return;
				}
			}
		} else if ($c->access_method == 1) {
			if (!hwd_vs_access::allowLevelAccess( $cat->access_lev_v, hwd_vs_access::userGID( $my->id ))) {
				hwd_vs_tools::infomessage(3, 0,  _HWDVIDS_TITLE_NOACCESS, _HWDVIDS_ALERT_NOT_AUTHORIZED, "exclamation.png", 0);
				return;
			}
		}

		// get subcategories
		$query = 'SELECT *'
				. ' FROM #__hwdvidscategories'
				. ' WHERE published = 1'
				. ' AND parent = '.$cat_id
				. ' ORDER BY category_name'
				;
		$db->setQuery( $query );
		$subcats = $db->loadObjectList();

        // sent out
        hwd_vs_html::viewCategory($option, $rows, $pageNav, $total, $cat_id, $cat, $subcats);
    }
    /**
     * Query SQL for user inputted search pattern
     *
     * @param string $option  the joomla component name
     * @return       Nothing
     */
    function search($option)
    {
        global $mainframe, $limitstart, $select, $joinv, $joing;
		$c = hwd_vs_Config::get_instance();
		$db = & JFactory::getDBO();
		$my = & JFactory::getUser();

		// number of videos and groups to display
        $limitv     = intval($c->vpp);
        $limitg     = intval($c->gpp);
        // get POST array values
        $searchterm = JRequest::getVar( 'searchterm', '' );
		$searchterm_safe = addslashes($searchterm);

        // setup search filter for videos and groups
        if (!$my->id) {
        $wherevids = ' WHERE public_private = \'public\' AND MATCH (title,tags,description) AGAINST (\''.$searchterm_safe.'\')';
        $wheregroups = ' WHERE public_private = \'public\' AND MATCH (group_name,group_description) AGAINST (\''.$searchterm_safe.'\')';
        } else {
        $wherevids = ' WHERE MATCH (title,tags,description) AGAINST (\''.$searchterm_safe.'\')';
        $wheregroups = ' WHERE MATCH (group_name,group_description) AGAINST (\''.$searchterm_safe.'\')';
        }
        // count matching videos
        $db->SetQuery( 'SELECT count(*)'
                            . ' FROM #__hwdvidsvideos'
                            . $wherevids
                            );
          $totalvids = $db->loadResult();
        echo $db->getErrorMsg();
        // pagination
        $videoNav = new mosPageNav( $totalvids, $limitstart, $limitv );
        // get matching video data
        $query = 'SELECT'.$select
                . ' FROM #__hwdvidsvideos AS a'
				. $joinv
                . $wherevids
                ;
        $db->SetQuery($query, $videoNav->limitstart, $videoNav->limit);
        $matchingvids = $db->loadObjectList();

        // count matching groups
        $db->SetQuery( 'SELECT count(*)'
                            . ' FROM #__hwdvidsgroups'
                            . $wheregroups
                            );
        $totalgroups = $db->loadResult();
        echo $db->getErrorMsg();

        // pagination
        $groupNav = new mosPageNav( $totalgroups, $limitstart, $limitg );
        // get matching group data
        $query = 'SELECT'.$select
                . ' FROM #__hwdvidsgroups AS a'
				. $joing
                . $wheregroups
                ;
        $db->SetQuery($query, $groupNav->limitstart, $groupNav->limit);
        $matchinggroups = $db->loadObjectList();

        // sent out
        hwd_vs_html::search($option, $totalvids, $matchingvids, $videoNav, $totalgroups, $matchinggroups, $groupNav, $searchterm);
    }
    /**
     * Query SQL for all accessible category data
     *
     * @param string $option  the joomla component name
     * @return       Nothing
     */
    function downloadFile($option)
    {
        global $mainframe, $limitstart;
		$c = hwd_vs_Config::get_instance();
		$db = & JFactory::getDBO();
		$my = & JFactory::getUser();
		$evp = JRequest::getCmd( 'evp', 0 );
		$file = JRequest::getCmd( 'file', 0 );
		$deliver = JRequest::getCmd( 'deliver', 0 );
		$media = JRequest::getCmd( 'media', 0 );

        $db->SetQuery( 'SELECT count(*)'
                       . ' FROM #__hwdvidsantileech'
                       . ' WHERE expiration = "'.$evp.'"'
                            );
        $result = $db->loadResult();

		if ($result > 0)
		{
			$db->SetQuery("DELETE FROM #__hwdvidsantileech WHERE expiration = \"$evp\"");
			$db->Query();

			$BASEPATH = JPATH_SITE."/hwdvideos"; 		// Set this to the absolute path to your protected media files. No trailing slash!

			if ($media == "local") {
				$path = "$BASEPATH/uploads/".$file.".flv";
				$url = JURI::root()."hwdvideos/uploads/".$file.".flv";
			} else if ($media == "swf") {
				$path = "$BASEPATH/uploads/".$file.".swf";
				$url = JURI::root()."hwdvideos/uploads/".$file.".flv";
			}

			if ($deliver == "player") {
				header('Location: '.$url);
			} else {
				// Transfer file in chunks to preserve memory on the server
				$fn = basename($path);
				header('Content-Type: application/octet-stream');
				header("Content-Disposition: attachment; filename=\"$fn\"");
				header('Content-Length: '.filesize($path));
				@hwd_vs_tools::readfile_chunked($path, false);
			}
		}
		else
		{
			header("Location: ".JURI::root( true ));
		}
    }
}
