<?php
/**
 *    @version 2.1.1 Build 21106 Alpha [ Drury ]
 *    @package hwdVideoShare
 *    @copyright (C) 2007 - 2009 Highwood Design
 *    @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 ***
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

/**
 * This class is the HTML generator for hwdVideoShare frontend
 *
 * @package    hwdVideoShare
 * @author     Dave Horsfall <info@highwooddesign.co.uk>
 * @copyright  2008 Highwood Design
 * @license    http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @version    1.1.4 Alpha RC2.13
 */
class hwd_vs_groups
{
    /**
     * Outputs frontpage HTML
     *
     * @param string $option  the joomla component name
     * @param array  $rows  array of video data
     * @param array  $rowsfeatured  array of featured video data
     * @param object $pageNav  page navigation object
     * @param int    $total  the total video count
     * @return       Nothing
     */
    function groups($option)
	{
		global $mainframe, $limitstart, $mosConfig_live_site, $mosConfig_allowUserRegistration;
		$c = hwd_vs_Config::get_instance();
		$db = & JFactory::getDBO();
		$my = & JFactory::getUser();
		$acl= & JFactory::getACL();

		// check component access settings and deny those without privileges
		if ($c->access_method == 0) {
			if (!hwd_vs_access::allowAccess( $c->gtree_grup, $c->gtree_grup_child, hwd_vs_access::userGID( $my->id ))) {
				if ( ($my->id < 1) && (!$mosConfig_allowUserRegistration == '0' && hwd_vs_access::allowAccess( $c->gtree_grup, 'RECURSE', $acl->get_group_id('Registered','ARO') ) ) ) {
					hwd_vs_tools::infomessage(3, 0, _HWDVIDS_TITLE_NOACCESS, _HWDVIDS_ALERT_REGISTERFORGRUP, "exclamation.png", 1);
					return;
				} else {
					hwd_vs_tools::infomessage(3, 0, _HWDVIDS_TITLE_NOACCESS, _HWDVIDS_ALERT_GRUP_NOT_AUTHORIZED, "exclamation.png", 1);
					return;
				}
			}
		} else if ($c->access_method == 1) {
			if (!hwd_vs_access::allowLevelAccess( $c->accesslevel_grup, hwd_vs_access::userGID( $my->id ))) {
				hwd_vs_tools::infomessage(3, 0,  _HWDVIDS_TITLE_NOACCESS, _HWDVIDS_ALERT_NOT_AUTHORIZED, "exclamation.png", 0);
				return;
			}
		}



		$limit 	= intval($c->gpp);

		$where = ' WHERE a.published = 1';
		if (!$my->id) {
		$where .= ' AND a.public_private = "public"';
		}

		$db->SetQuery( 'SELECT count(*)'
							. ' FROM #__hwdvidsgroups AS a'
							. $where
							);
  		$total = $db->loadResult();
		echo $db->getErrorMsg();

		$pageNav = new mosPageNav( $total, $limitstart, $limit );

		//Groups that are published
		$query = 'SELECT a.*, u.name, u.username'
				. ' FROM #__hwdvidsgroups AS a'
				. ' LEFT JOIN #__users AS u ON u.id = a.adminid'
				. $where
				. ' ORDER BY a.date DESC'
				;

		$db->SetQuery($query, $pageNav->limitstart, $pageNav->limit);
		$rows = $db->loadObjectList();

		//Featured groups
		$query = 'SELECT a.*, u.name, u.username'
				. ' FROM #__hwdvidsgroups AS a'
				. ' LEFT JOIN #__users AS u ON u.id = a.adminid'
				. $where
		        . ' AND a.featured = 1'
				. ' ORDER BY a.date DESC'
				. ' LIMIT 0, '.$c->fpfeaturedgroups
				;

		$db->SetQuery($query);
		$rowsfeatured = $db->loadObjectList();

		hwd_vs_html::groups($option, $rows, $rowsfeatured, $pageNav, $total);
	}
    /**
     * Outputs frontpage HTML
     *
     * @param string $option  the joomla component name
     * @param array  $rows  array of video data
     * @param array  $rowsfeatured  array of featured video data
     * @param object $pageNav  page navigation object
     * @param int    $total  the total video count
     * @return       Nothing
     */
	function creategroup($option)
	{
		global $mosConfig_live_site, $Itemid;
		$c = hwd_vs_Config::get_instance();
		$db = & JFactory::getDBO();
		$my = & JFactory::getUser();
		$acl= & JFactory::getACL();

		if (!$my->id) {
        	hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_NOACCESS, _HWDVIDS_ALERT_LOG2ADDG, "exclamation.png", 0);
			return;
		}

		hwd_vs_html::createGroup($option);
	}
    /**
     * Outputs frontpage HTML
     *
     * @param string $option  the joomla component name
     * @param array  $rows  array of video data
     * @param array  $rowsfeatured  array of featured video data
     * @param object $pageNav  page navigation object
     * @param int    $total  the total video count
     * @return       Nothing
     */
	function deletegroup($option)
	{
		global $mainframe, $Itemid;
		$c = hwd_vs_Config::get_instance();
		$db = & JFactory::getDBO();
		$my = & JFactory::getUser();
		$acl= & JFactory::getACL();

		$userid = $my->id;
		$groupid	= JRequest::getInt( 'groupid', 0 );

		if (!$my->id) {
			$msg = _HWDVIDS_ALERT_LOG2REMG;
			mosRedirect( $mosConfig_live_site."/index.php?option=com_hwdvideoshare&task=groups&Itemid=".$Itemid, $msg );
		}

		$db->SetQuery("DELETE FROM #__hwdvidsgroups WHERE id = $groupid AND adminid = $my->id");
		$db->Query();
		if ( !$db->query() ) {
			echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
		}

		$db->SetQuery("DELETE FROM #__hwdvidsgroup_membership WHERE groupid = $groupid");
		$db->Query();
		if ( !$db->query() ) {
			echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
		}

		$db->SetQuery("DELETE FROM #__hwdvidsgroup_videos WHERE groupid = $groupid");
		$db->Query();
		if ( !$db->query() ) {
			echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
		}

		$msg = _HWDVIDS_ALERT_GREMOVED;
		$mainframe->enqueueMessage($msg);
		$mainframe->redirect( JURI::root( true ) . '/index.php?option=com_hwdvideoshare&task=groups&Itemid='.$Itemid );
	}
    /**
     * Outputs frontpage HTML
     *
     * @param string $option  the joomla component name
     * @param array  $rows  array of video data
     * @param array  $rowsfeatured  array of featured video data
     * @param object $pageNav  page navigation object
     * @param int    $total  the total video count
     * @return       Nothing
     */
	function viewGroup($option)
	{
		global $mainframe, $mosConfig_live_site, $limitstart, $Itemid;
		$c = hwd_vs_Config::get_instance();
		$db = & JFactory::getDBO();
		$my = & JFactory::getUser();
		$acl= & JFactory::getACL();

		$groupid = JRequest::getInt( 'group_id', 0, 'request' );

		$limit 	= intval($c->vpp);

		$where = ' WHERE published = 1';
		$where .= ' AND id = '.(int)$groupid;
		if (!$my->id) {
		$where .= ' AND public_private = "public"';
		}

		//Check group can be viewed
		$db->SetQuery( 'SELECT count(*)'
						. ' FROM #__hwdvidsgroups'
						. $where
							);
  		$groupexists = $db->loadResult();
		echo $db->getErrorMsg();
		if ( $groupexists<1 ) {
			echo "<div id=\"hwdvids\">";
			hwd_vs_html_nav::navigation(1);
			echo "<img src=\"".$mosConfig_live_site."/components/com_hwdvideoshare/images/icons/exclamation.png\" />&nbsp;&nbsp;"._HWDVIDS_ALERT_GROUPNOEXIST;
			hwd_vs_html_footer::tidyup();
			echo "</div>";
			return;
		}



		$where = ' WHERE a.published = 1';
		$where .= ' AND a.approved = "yes"';
		$where .= ' AND l.groupid = '.$groupid;

		$db->SetQuery( 'SELECT count(*)'
							. ' FROM #__hwdvidsvideos AS a'
							. ' LEFT JOIN #__hwdvidsgroup_videos AS l ON l.videoid = a.id'
							. $where
							);
  		$total = $db->loadResult();
		echo $db->getErrorMsg();

		$pageNav = new mosPageNav( $total, $limitstart, $limit );

		//Videos that are approved(converted) and published in this group
		$query = 'SELECT a.*, u.name, u.username'
				. ' FROM #__hwdvidsvideos AS a'
				. ' LEFT JOIN #__hwdvidsgroup_videos AS l ON l.videoid = a.id'
				. ' LEFT JOIN #__users AS u ON u.id = a.adminid'
				. $where
				. ' ORDER BY a.date_uploaded DESC'
				;

		$db->SetQuery($query, $pageNav->limitstart, $pageNav->limit);
		$rows = $db->loadObjectList();

		//Videos that are approved(converted) and published in this group
		$query = 'SELECT m.*, u.name, u.username'
				. ' FROM #__hwdvidsgroup_membership AS m'
				. ' LEFT JOIN #__users AS u ON u.id = m.memberid'
		        . ' WHERE m.groupid = '.$groupid
		        . ' AND m.approved = 1'
				. ' ORDER BY date DESC'
				;

		$db->SetQuery($query);
		$members = $db->loadObjectList();

		//Group details
		$query = 'SELECT a.*, u.name, u.username'
				. ' FROM #__hwdvidsgroups AS a'
				. ' LEFT JOIN #__users AS u ON u.id = a.adminid'
				. ' WHERE a.id = '.$groupid
				. ' ORDER BY id DESC'
				;

		$db->SetQuery( $query );
    	$groupdetails = $db->loadObject();

		hwd_vs_html::viewGroup($option, $rows, $pageNav, $total, $members, $groupdetails);
	}
    /**
     * Outputs frontpage HTML
     *
     * @param string $option  the joomla component name
     * @param array  $rows  array of video data
     * @param array  $rowsfeatured  array of featured video data
     * @param object $pageNav  page navigation object
     * @param int    $total  the total video count
     * @return       Nothing
     */
    function savegroup($option)
	{
		global $option, $mainframe, $params, $Itemid, $mosConfig_absolute_path, $mosConfig_mailfrom, $mosConfig_fromname, $mosConfig_live_site, $mosConfig_sitename;
		$c = hwd_vs_Config::get_instance();
		$db = & JFactory::getDBO();
		$my = & JFactory::getUser();
		$acl= & JFactory::getACL();

		if ($c->disablecaptcha == "0") {
			$sessid = session_id();
			if (empty($sessid)) {
				session_start();
			}
			if(($_SESSION['security_code'] == $_POST['security_code']) && (!empty($_SESSION['security_code'])) ) {
				// Insert you code for processing the form here, e.g emailing the submission, entering it into a database.
   		    	hwd_vs_groups::bindNewGroup($option);
				unset($_SESSION['security_code']);
			} else {
				// Insert your code for showing an error message here
				$msg = _HWDVIDS_ALERT_ERRSC;
				echo "<div id=\"hwdvids\">";
				hwd_vs_html_nav::navigation(3);
				hwd_vs_html_nav::usernavigation(0);
				echo "<img src=\"".$mosConfig_live_site."/components/com_hwdvideoshare/images/icons/exclamation.png\" />&nbsp;&nbsp;".$msg."<br /><br />";
				hwd_vs_html_footer::tidyup();
				echo "</div>";
				return;
			}

   		} else {
   		    hwd_vs_groups::bindNewGroup($option);
		}
	}
    /**
     * Outputs frontpage HTML
     *
     * @param string $option  the joomla component name
     * @param array  $rows  array of video data
     * @param array  $rowsfeatured  array of featured video data
     * @param object $pageNav  page navigation object
     * @param int    $total  the total video count
     * @return       Nothing
     */
    function bindNewGroup($option)
	{
		global $option, $mainframe, $params, $Itemid, $mosConfig_absolute_path, $mosConfig_mailfrom, $mosConfig_fromname, $mosConfig_live_site, $mosConfig_sitename;
		$c = hwd_vs_Config::get_instance();
		$db = & JFactory::getDBO();
		$my = & JFactory::getUser();
		$acl= & JFactory::getACL();

			$group_name 		= Jrequest::getVar( 'group_name', _HWDVIDS_UNKNOWN );
			$public_private 	= JRequest::getWord( 'public_private' );
			$date 				= date('Y-m-d H:i:s');
			$allow_comments		= JRequest::getInt( 'allow_comments', 0, 'request' );
			$require_approval   = JRequest::getInt( 'require_approval', 0, 'request' );
			$group_description  = Jrequest::getVar( 'group_description', _HWDVIDS_UNKNOWN );
			$featured			= 0;
			$adminid            = $my->id;
			if ($c->aag == 1) {
				$published = 1;
			} else {
				$published = 0;
			}

			$checkform = hwd_vs_tools::checkGroupFormComplete( $group_name, $public_private, $allow_comments, $group_description );
			if (!$checkform) { return; }

			$row = new hwdvids_group($db);

			$_POST['group_name'] 		= $group_name;
			$_POST['public_private'] 	= $public_private;
			$_POST['date'] 				= $date;
			$_POST['allow_comments'] 	= $allow_comments;
			$_POST['require_approval'] 	= $require_approval;
			$_POST['group_description'] = $group_description;
			$_POST['featured'] 			= $featured;
			$_POST['adminid'] 			= $adminid;
			$_POST['published'] 		= $published;

			// bind it to the table
			if (!$row -> bind($_POST)) {
				echo "<script> alert('"
					.$row -> getError()
					."'); window.history.go(-1); </script>\n";
				exit();
			}

			// store it in the db
			if (!$row -> store()) {
				echo "<script> alert('"
					.$row -> getError()
					."'); window.history.go(-1); </script>\n";
				exit();
			}

			// mail admin notification
			if ($c->mailgroupnotification == 1) {
				$mailbody = ""._HWDVIDS_MAIL_BODY3.$mosConfig_sitename.".\n";
				$mailbody .= ""._HWDVIDS_MAIL_BODY4."\"".stripslashes($_POST['group_name'])."\".\n";
				if (isset($row->id)) {
					$mailbody .= "".$mosConfig_live_site."/index.php?option=com_hwdvideoshare&Itemid=".$Itemid."&task=viewgroup&group_id=".$row->id."	\n";
				}
				$mailbody .= "\n"._HWDVIDS_MAIL_BODY5."\n";
				$mailbody .= $mosConfig_live_site."/administrator";

				JUtility::sendMail( $mosConfig_mailfrom, $mosConfig_fromname, $mailnotifyaddress, _HWDVIDS_MAIL_SUBJECT2.$mosConfig_sitename.' ', $mailbody );
			}

			// automatically add admin to group
			$autoa2g = @$_POST['add2group'];
			if (isset($autoa2g)) {
				if ($autoa2g == "1") {

					$date = date('Y-m-d H:i:s');
					$published = 1;

					$_POST['memberid'] = $my->id;
					$_POST['date'] = $date;
					$_POST['groupid'] = $row->id;
					$_POST['approved'] = 1;

					$row = new hwdvids_groupmember($db);

					// bind it to the table
					if (!$row -> bind($_POST)) {
						echo "<script> alert('"
							.$row -> getError()
							."'); window.history.go(-1); </script>\n";
						exit();
					}

					// store it in the db
					if (!$row -> store()) {
						echo "<script> alert('"
							.$row -> getError()
							."'); window.history.go(-1); </script>\n";
						exit();
					}
					$row->checkin();

					require_once(HWDVIDSPATH.'/../../administrator/components/com_hwdvideoshare/maintenance/recount.class.php');
					hwd_vs_recount::recountMembersInGroup($row->groupid);
				}
			}
			if ($c->aag == 1) {
				$msg = _HWDVIDS_ALERT_GSAVED;
			} else {
				$msg = _HWDVIDS_ALERT_GPENDING;
			}
			$mainframe->enqueueMessage($msg);
			$mainframe->redirect( JURI::root() . 'index.php?option=com_hwdvideoshare&task=groups&Itemid='.$Itemid );
	}
    /**
     * Outputs frontpage HTML
     *
     * @param string $option  the joomla component name
     * @param array  $rows  array of video data
     * @param array  $rowsfeatured  array of featured video data
     * @param object $pageNav  page navigation object
     * @param int    $total  the total video count
     * @return       Nothing
     */
    function joingroup($option)
	{
		global $Itemid, $mainframe;
		$c = hwd_vs_Config::get_instance();
		$db = & JFactory::getDBO();
		$my = & JFactory::getUser();
		$acl= & JFactory::getACL();

		$url =  Jrequest::getVar( 'url', JURI::root() );

		if (!$my->id) {
			$mainframe->enqueueMessage(_HWDVIDS_ALERT_LOG2JOING);
			$mainframe->redirect( $url );
		}

		$memberid = $my->id;
		$groupid = JRequest::getInt( 'groupid', 0 );

		$date = date('Y-m-d H:i:s');
		$published = 1;

		$row = new hwdvids_groupmember($db);

		$_POST['memberid'] = $memberid;
		$_POST['groupid'] = $groupid;
		$_POST['date'] = $date;
		$_POST['approved'] = 1;

		// bind it to the table
		if (!$row -> bind($_POST)) {
			echo "<script> alert('"
				.$row -> getError()
				."'); window.history.go(-1); </script>\n";
			exit();
		}

		// store it in the db
		if (!$row -> store()) {
			echo "<script> alert('"
				.$row -> getError()
				."'); window.history.go(-1); </script>\n";
			exit();
		}

		// perform maintenance
		include(HWDVIDSPATH.'/../../administrator/components/com_hwdvideoshare/maintenance/recount.class.php');
		hwd_vs_recount::recountMembersInGroup($groupid);

		$mainframe->enqueueMessage(_HWDVIDS_ALERT_SUCJOIN);
		$mainframe->redirect( $url );
	}
    /**
     * Outputs frontpage HTML
     *
     * @param string $option  the joomla component name
     * @param array  $rows  array of video data
     * @param array  $rowsfeatured  array of featured video data
     * @param object $pageNav  page navigation object
     * @param int    $total  the total video count
     * @return       Nothing
     */
    function leavegroup($option)
	{
		global $Itemid, $mainframe;
		$c = hwd_vs_Config::get_instance();
		$db = & JFactory::getDBO();
		$my = & JFactory::getUser();
		$acl= & JFactory::getACL();

		$url =  Jrequest::getVar( 'url', JURI::root() );

		if (!$my->id) {
			$mainframe->enqueueMessage(_HWDVIDS_ALERT_LOG2LEAVEG);
			$mainframe->redirect( $url );
		}

		$memberid = $my->id;
		$groupid = JRequest::getInt( 'groupid', 0 );

		$where = ' WHERE memberid = '.$memberid;
		$where .= ' AND groupid = '.$groupid;

		$db->SetQuery( 'DELETE FROM #__hwdvidsgroup_membership'
							. $where
							);

		if ( !$db->query() ) {
			echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
			exit();
		}

		// perform maintenance
		include(HWDVIDSPATH.'/../../administrator/components/com_hwdvideoshare/maintenance/recount.class.php');
		hwd_vs_recount::recountMembersInGroup($groupid);

		$mainframe->enqueueMessage(_HWDVIDS_ALERT_SUCLEAVE);
		$mainframe->redirect( $url );
  	}
    /**
     * Outputs frontpage HTML
     *
     * @param string $option  the joomla component name
     * @param array  $rows  array of video data
     * @param array  $rowsfeatured  array of featured video data
     * @param object $pageNav  page navigation object
     * @param int    $total  the total video count
     * @return       Nothing
     */
    function editGroup($option)
	{
		global $mosConfig_live_site, $mainframe, $Itemid;
		$c = hwd_vs_Config::get_instance();
		$db = & JFactory::getDBO();
		$my = & JFactory::getUser();
		$acl= & JFactory::getACL();

		$groupid = JRequest::getInt( 'groupid', 0 );

		$row = new hwdvids_group($db);
		$row->load( $groupid );

		// fail if checked out not by user
		if ($row->isCheckedOut( $my->id )) {
			$mainframe->enqueueMessage(_HWDVIDS_ALERTCO1.' '.$row->title.' '. _HWDVIDS_ALERTCO2);
			$mainframe->redirect( JURI::root() . 'index.php?option=com_hwdvideoshare&task=groups&Itemid='.$Itemid );
		}

		//check valid user
		if ($row->adminid != $my->id) {
			$mainframe->enqueueMessage(_HWDVIDS_ALERT_NOPERM);
			$mainframe->redirect( JURI::root() . 'index.php?option=com_hwdvideoshare&task=groups&Itemid='.$Itemid );
		}


		//Videos that are approved(converted) and published in this group
		$query = 'SELECT *'
				. ' FROM #__hwdvidsgroup_membership'
				;
		$db->SetQuery($query);
		$grp_members = $db->loadObjectList();

		hwd_vs_html::editGroupInfo($option, $row, $grp_members);
  	}

}
?>