<?php
/**
 *    @version 2.1.1 Build 21106 Alpha [ Drury ]
 *    @package hwdVideoShare
 *    @copyright (C) 2007 - 2009 Highwood Design
 *    @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 ***
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

/**
 * This class is the HTML generator for hwdVideoShare frontend
 *
 * @package    hwdVideoShare
 * @author     Dave Horsfall <info@highwooddesign.co.uk>
 * @copyright  2008 Highwood Design
 * @license    http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @version    1.1.4 Alpha RC2.13
 */
class hwd_vs_uploads
{
    /**
     * Outputs frontpage HTML
     *
     * @param string $option  the joomla component name
     * @param array  $rows  array of video data
     * @param array  $rowsfeatured  array of featured video data
     * @param object $pageNav  page navigation object
     * @param int    $total  the total video count
     * @return       Nothing
     */
    function uploadConfirmPerl()
	{
	global $database, $my, $acl, $mosConfig_absolute_path, $mosConfig_mailfrom, $mosConfig_fromname, $mosConfig_live_site, $option, $Itemid, $mosConfig_sitename;
		$c = hwd_vs_Config::get_instance();
		$db = & JFactory::getDBO();
		$my = & JFactory::getUser();
		$acl= & JFactory::getACL();

	// get server configuration data
	require_once(HWDVIDSPATH.'/../../administrator/components/com_hwdvideoshare/serverconfig.hwdvideoshare.php');
	$s = hwd_vs_SConfig::get_instance();

	//******************************************************************************************************
	//   ATTENTION: THIS FILE HEADER MUST REMAIN INTACT. DO NOT DELETE OR MODIFY THIS FILE HEADER.
	//
	//   Name: ubr_finished.php
	//   Revision: 1.3
	//   Date: 2/18/2008 5:36:57 PM
	//   Link: http://uber-uploader.sourceforge.net
	//   Initial Developer: Peter Schmandra  http://www.webdice.org
	//   Description: Show successful file uploads.
	//
	//   Licence:
	//   The contents of this file are subject to the Mozilla Public
	//   License Version 1.1 (the "License"); you may not use this file
	//   except in compliance with the License. You may obtain a copy of
	//   the License at http://www.mozilla.org/MPL/
	//
	//   Software distributed under the License is distributed on an "AS
	//   IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
	//   implied. See the License for the specific language governing
	//   rights and limitations under the License.
	//
	//***************************************************************************************************************

	//***************************************************************************************************************
	// The following possible query string formats are assumed
	//
	// 1. ?upload_id=upload_id
	// 2. ?about=1
	//****************************************************************************************************************

	$THIS_VERSION = "1.3";                                // Version of this file
	$UPLOAD_ID = '';                                      // Initialize upload id

	require (HWDVIDSPATH.'/uploads/perl/ubr_ini.php');
	require (HWDVIDSPATH.'/uploads/perl/ubr_lib.php');
	require (HWDVIDSPATH.'/uploads/perl/ubr_finished_lib.php');
	//require (HWDVIDSPATH.'/uploads/perl/image_lib.php');

	if($PHP_ERROR_REPORTING){ error_reporting(E_ALL); }

	header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
	header('Last-Modified: '.date('r'));
	header('Cache-Control: no-store, no-cache, must-revalidate');
	header('Cache-Control: post-check=0, pre-check=0', FALSE);
	header('Pragma: no-cache');

	if(preg_match("/^[a-zA-Z0-9]{32}$/", $_GET['upload_id'])){ $UPLOAD_ID = $_GET['upload_id']; }
	elseif(isset($_GET['about']) && $_GET['about'] == 1){ kak("<u><b>UBER UPLOADER FINISHED PAGE</b></u><br>UBER UPLOADER VERSION =  <b>" . $UBER_VERSION . "</b><br>UBR_FINISHED = <b>" . $THIS_VERSION . "<b><br>\n", 1 , __LINE__); }
	else{ kak("<font color='red'>ERROR</font>: Invalid parameters passed<br>", 1, __LINE__); }

	//Declare local values
	$_XML_DATA = array();                                          // Array of xml data read from the upload_id.redirect file
	$_CONFIG_DATA = array();                                       // Array of config data read from the $_XML_DATA array
	$_POST_DATA = array();                                         // Array of posted data read from the $_XML_DATA array
	$_FILE_DATA = array();                                         // Array of 'FileInfo' objects read from the $_XML_DATA array
	$_FILE_DATA_TABLE = '';                                        // String used to store file info results nested between <tr> tags
	$_FILE_DATA_EMAIL = '';                                        // String used to store file info results

	$xml_parser = new XML_Parser;                                  // XML parser
	$xml_parser->setXMLFile($TEMP_DIR, $_REQUEST['upload_id']);    // Set upload_id.redirect file
	$xml_parser->setXMLFileDelete($DELETE_REDIRECT_FILE);          // Delete upload_id.redirect file when finished parsing
	$xml_parser->parseFeed();                                      // Parse upload_id.redirect file

	// Display message if the XML parser encountered an error
	if($xml_parser->getError()){ kak($xml_parser->getErrorMsg(), 1, __LINE__); }

	$_XML_DATA = $xml_parser->getXMLData();                        // Get xml data from the xml parser
	$_CONFIG_DATA = getConfigData($_XML_DATA);                     // Get config data from the xml data
	$_POST_DATA  = getPostData($_XML_DATA);                        // Get post data from the xml data
	$_FILE_DATA = getFileData($_XML_DATA);                         // Get file data from the xml data


	// Output XML DATA, CONFIG DATA, POST DATA, FILE DATA to screen and exit if DEBUG_ENABLED.
	if($DEBUG_FINISHED){
		debug("<br><u>XML DATA</u>", $_XML_DATA);
		debug("<u>CONFIG DATA</u>", $_CONFIG_DATA);
		debug("<u>POST DATA</u>", $_POST_DATA);
		debug("<u>FILE DATA</u><br>", $_FILE_DATA);
		exit;
	}


	/////////////////////////////////////////////////////////////////////////////////////////////////
	//
	//           *** ATTENTION: ENTER YOUR CODE HERE !!! ***
	//
	// This is a good place to put your post upload code. Like saving the
	// uploaded file information to your DB or doing some image
	// manipulation. etc. Everything you need is in the
	// $XML DATA, $_CONFIG_DATA, $_POST_DATA and $_FILE_DATA arrays.
	//
	/////////////////////////////////////////////////////////////////////////////////////////////////
	// NOTE: You can now access all XML values below this comment. eg.
	//   $_XML_DATA['upload_dir']; or $_XML_DATA['link_to_upload'] etc
	/////////////////////////////////////////////////////////////////////////////////////////////////
	// NOTE: You can now access all config values below this comment. eg.
	//   $_CONFIG_DATA['upload_dir']; or $_CONFIG_DATA['link_to_upload'] etc
	/////////////////////////////////////////////////////////////////////////////////////////////////
	// NOTE: You can now access all post values below this comment. eg.
	//   $_POST_DATA['client_id']; or $_POST_DATA['check_box_1_'] etc
	/////////////////////////////////////////////////////////////////////////////////////////////////
	// NOTE: You can now access all file (slot, name, size, type) info below this comment. eg.
	//   $_FILE_DATA[0]->name  or  $_FILE_DATA[0]->getFileInfo('name')
	/////////////////////////////////////////////////////////////////////////////////////////////////

	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// Create thumnail example  (must uncomment line 34)
	// if( $_FILE_DATA[0]->type  == 'image/jpeg'){ $success = createThumbFile($_CONFIG_DATA['upload_dir'],  $_FILE_DATA[0]->name, $_CONFIG_DATA['upload_dir'],  120,  100);  }
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	//Create file upload table
	$_FILE_DATA_TABLE = getFileDataTable($_FILE_DATA, $_CONFIG_DATA);

	// Create and send email
	if($_CONFIG_DATA['send_email_on_upload']){ emailUploadResults($_FILE_DATA, $_CONFIG_DATA, $_POST_DATA); }

		$file_name = $_FILE_DATA[0]->name;
		$file_ext = substr($file_name, strrpos($file_name, '.') + 1);
		$file_video_name = $file_name;
		$file_video_id = substr($file_name, 0, -(strlen($file_ext)+1));

		$title 				= $_POST_DATA['title'];
		$description 		= $_POST_DATA['description'];
		$category_id 		= intval ($_POST_DATA['category_id']);
		$tags 				= $_POST_DATA['tags'];
		$public_private 	= $_POST_DATA['public_private'];
		$allow_comments 	= intval ($_POST_DATA['allow_comments']);
		$allow_embedding 	= intval ($_POST_DATA['allow_embedding']);
		$allow_ratings 		= intval ($_POST_DATA['allow_ratings']);

		// check encoding and compare to system encoding
		// fix if necessary
		if (function_exists('mb_detect_encoding')) {
			if (preg_match("/iso/i", _ISO) > 0) {
					$title 				= utf8_decode($title);
					$description 		= utf8_decode($description);
					$tags 				= utf8_decode($tags);
			}
		}

		$checkform = hwd_vs_tools::checkFormComplete($title, $description, $category_id, $tags, $public_private, $allow_comments, $allow_embedding, $allow_ratings);
		if (!$checkform) { return; }

		// initialise database
		$row = new hwdvids_video($db);

		if ($file_ext == "swf") {
			$_POST['video_type'] 		= "swf";
		} else {
			$_POST['video_type'] 		= "local";
		}
		$_POST['title'] 			= $title;
		$_POST['description'] 		= $description;
		$_POST['category_id'] 		= $category_id;
		$_POST['tags'] 				= $tags;
		$_POST['public_private'] 	= $public_private;
		$_POST['allow_comments'] 	= $allow_comments;
		$_POST['allow_embedding'] 	= $allow_embedding;
		$_POST['allow_ratings'] 	= $allow_ratings;
		$_POST['date_uploaded'] 	= date('Y-m-d H:i:s');
		$_POST['user_id'] 			= $my->id;
		$_POST['published'] 		= 1;

		if ($c->requiredins == 1) {
			$_POST['video_id'] 		= $file_video_name;
			// check if we are reprocessing
			if ($c->reconvertflv == 0) {
				if ($file_ext == "flv") {
					$_POST['approved'] = "queuedforthumbnail";
				} else if ($file_ext == "swf") {
					$_POST['approved'] = "queuedforswf";
				} else {
					$_POST['approved'] = "queuedforconversion";
				}
			} else {
				if ($file_ext == "swf") {
					$_POST['approved'] = "queuedforswf";
				} else {
					$_POST['approved'] = "queuedforconversion";
				}
			}
		} else if ($c->requiredins == 0) {
			$originals_Dir = HWDVIDSPATH.'/../../hwdvideos/uploads/originals/';
			$base_Dir = HWDVIDSPATH.'/../../hwdvideos/uploads/';

			if (!copy($originals_Dir.$_FILE_DATA[0]->name, $base_Dir.$_FILE_DATA[0]->name)) {
        		hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_ERROR_UPLDERR00, "exclamation.png", 0);
				return;
			} else {
				if ($c->deleteoriginal == 1) {
					if (file_exists($base_Dir.$_FILE_DATA[0]->name)) {
						@unlink($originals_Dir.$_FILE_DATA[0]->name);
					}
				}
				if ($c->aav == 1) {
					$_POST['approved'] = "yes";
				} else {
					$_POST['approved'] = "pending";
				}
			}
			$_POST['video_id'] 		= $file_video_id;
		}

		//check if already exists
		$db->SetQuery( 'SELECT count(*)'
						. ' FROM #__hwdvidsvideos'
						. ' WHERE video_id = "'.$file_video_id.'"'
						);
		$duplicatecount = $db->loadResult();
		if ($duplicatecount > 0) {
        	hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_ERROR_UPLDERR00, "exclamation.png", 0);
			return;
		}

		if(empty($_POST['video_id'])) {
        	hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_ERROR_UPLDERR00, "exclamation.png", 0);
			return;
		}

		// bind it to the table
		if (!$row->bind($_POST)) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		// store it in the db
		if (!$row->store()) {
			echo "<script> alert('".$row -> getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		// mail admin notification
		if ($c->mailvideonotification == 1) {
			$mailbody = ""._HWDVIDS_MAIL_BODY0.$mosConfig_sitename.".\n";
			$mailbody .= ""._HWDVIDS_MAIL_BODY1."\"".$_POST['title']."\".\n";
			$mailbody .= "".$mosConfig_live_site."/index.php?option=com_hwdvideoshare&Itemid=".$Itemid."&task=viewvideo&video_id=".$row->id."\n";
			$mailbody .= ""._HWDVIDS_MAIL_BODY2."\n";
			$mailbody .= $mosConfig_live_site."/administrator";

			JUtility::sendMail( $mosConfig_mailfrom, $mosConfig_fromname, $c->mailnotifyaddress, _HWDVIDS_MAIL_SUBJECT1.$mosConfig_sitename.' ', $mailbody );
		}

		// send upload to converter if required
		if ($c->requiredins == 1) {
			if ($c->autoconvert == "direct") {
				@exec("env -i $s->phppath ".HWDVIDSPATH."/converters/converter.php &>/dev/null &");
			} else if ($c->autoconvert == "wget") {
				@exec("env -i $s->wgetpath -O - -q ".JURI::root()."components/com_hwdvideoshare/converters/converter.php &>/dev/null &");
			}
		}


		// perform maintenance
		include(HWDVIDSPATH.'/../../administrator/components/com_hwdvideoshare/maintenance/recount.class.php');
		hwd_vs_recount::recountVideosInCategory($row->category_id);
		if (file_exists(HWDVIDSPATH.'/../../administrator/components/com_hwdrevenuemanager/redrawplaylist.class.php')) {
			require_once(HWDVIDSPATH.'/../../administrator/components/com_hwdrevenuemanager/redrawplaylist.class.php');
			hwd_rm_playlist::writeFile($row);
		}

		if ($c->cbint == 2) {
			require_once( JPATH_SITE . DS . 'components' . DS . 'com_community' . DS . 'libraries' . DS . 'core.php' );
			require_once( JPATH_SITE . DS . 'components' . DS . 'com_community' . DS . 'libraries' . DS . 'error.php' );

			$act = new stdClass();
			$act->cmd 	= 'video.upload';
			$act->actor 	= $my->id;
			$act->target 	= 0; // no target
			$act->title 	= JText::_('{actor} has uploaded {single}a new {app} video{/single}{multiple}{count} {app} videos{/multiple}');
			$act->content 	= '';
			$act->app 	= 'hwdvideoshare';
			$act->cid 	= 0;

			CFactory::load('libraries', 'activities');
			CActivityStream::add($act);
		}

		hwd_vs_html::uploadConfirm($option, $title);
	}
    /**
     * Outputs frontpage HTML
     *
     * @param string $option  the joomla component name
     * @param array  $rows  array of video data
     * @param array  $rowsfeatured  array of featured video data
     * @param object $pageNav  page navigation object
     * @param int    $total  the total video count
     * @return       Nothing
     */
    function uploadConfirmFlash()
	{
	global $database, $my, $acl, $mosConfig_absolute_path, $mosConfig_mailfrom, $mosConfig_fromname, $mosConfig_live_site, $option, $Itemid, $mosConfig_sitename;
		$c = hwd_vs_Config::get_instance();
		$db = & JFactory::getDBO();
		$my = & JFactory::getUser();
		$acl= & JFactory::getACL();

		// get server configuration data
		require_once(HWDVIDSPATH.'/../../administrator/components/com_hwdvideoshare/serverconfig.hwdvideoshare.php');
		$s = hwd_vs_SConfig::get_instance();

		$uploadDir = HWDVIDSPATH.'/../../hwdvideos/uploads/originals/';

		// generate random filename
		$file_video_id = hwd_vs_tools::generateNewVideoid();

		if (isset($_FILES['myFile'])) {
			// Javascript off, we need to upload the file
			$file_name0= (isset($_FILES['myFile']['tmp_name']) ? $_FILES['myFile']['tmp_name'] : "");
			$file_name = (isset($_FILES['myFile']['name']) ? $_FILES['myFile']['name'] : "");
			$file_size = (isset($_FILES['myFile']['size']) ? $_FILES['myFile']['size'] : "");

			if (!isset($_FILES['myFile']['error'])) {
				hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_PHPUPLD_ERR00, "exclamation.png", 0);
				return;
			} else if ($_FILES['myFile']['error'] == 8) {
				hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_PHPUPLD_ERR08, "exclamation.png", 0);
				return;
			} else if ($_FILES['myFile']['error'] == 7) {
				hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_PHPUPLD_ERR07, "exclamation.png", 0);
				return;
			} else if ($_FILES['myFile']['error'] == 6) {
				hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_PHPUPLD_ERR06, "exclamation.png", 0);
				return;
			} else if ($_FILES['myFile']['error'] == 5) {
				hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_PHPUPLD_ERR05, "exclamation.png", 0);
				return;
			} else if ($_FILES['myFile']['error'] == 4) {
				hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_PHPUPLD_ERR04, "exclamation.png", 0);
				return;
			} else if ($_FILES['myFile']['error'] == 3) {
				hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_PHPUPLD_ERR03, "exclamation.png", 0);
				return;
			} else if ($_FILES['myFile']['error'] == 2) {
				hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_PHPUPLD_ERR02, "exclamation.png", 0);
				return;
			} else if ($_FILES['myFile']['error'] == 1) {
				hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_PHPUPLD_ERR01, "exclamation.png", 0);
				return;
			} else if ($_FILES['myFile']['error'] == 0) {

				if (!empty($file_name)) {
					// get extension and create new random filename
					$file_ext = substr($file_name, strrpos($file_name, '.') + 1);
					$file_video_name = $file_video_id.".".$file_ext;
				}

				if (empty($file_video_name)) {
					hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_ERROR_UPLDERR00, "exclamation.png", 0);
					return;
				}

				$sizelimit = $c->maxupld*1024*1024; //size limit in mb
				if ($file_size > $sizelimit) {
					hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_ERROR_UPLDERR02." ".$c->maxupld."MB.", "exclamation.png", 0);
					return;
				}

				$filename = split("\.", $file_video_name);
				if (eregi("[^0-9a-zA-Z_]", $filename[0])) {
					hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_ERROR_UPLDERR03, "exclamation.png", 0);
					return;
				}

				// check file extensions
				if (($c->ft_mpg == "on" && $file_ext == "mpg") || ($c->ft_mpeg == "on" && $file_ext == "mpeg") || ($c->ft_avi == "on" && $file_ext == "avi") || ($c->ft_divx == "on" && $file_ext == "divx") || ($c->ft_mp4 == "on" && $file_ext == "mp4") || ($c->ft_flv == "on" && $file_ext == "flv") || ($c->ft_wmv == "on" && $file_ext == "wmv") || ($c->ft_rm == "on" && $file_ext == "rm") || ($c->ft_mov == "on" && $file_ext == "mov") || ($c->ft_moov == "on" && $file_ext == "moov") || ($c->ft_asf == "on" && $file_ext == "asf") || ($c->ft_swf == "on" && $file_ext == "swf") || ($c->ft_vob == "on" && $file_ext == "vob")) {
				} else {
					hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_ERROR_UPLDERR04, "exclamation.png", 0);
					return;
				}
				// move to uploaded file directory
				$file_video_path = $uploadDir . $file_video_name;
				if (file_exists($base_Dir.$file_video_name)) {
					hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_ERROR_UPLDERR05, "exclamation.png", 0);
					return;
				}
				if (!move_uploaded_file ($_FILES['myFile']['tmp_name'],$file_video_path) || !JPath::setPermissions(file_video_path)) {
					hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_ERROR_UPLDERR06, "exclamation.png", 0);
					return;
				}
			}
		} else if (isset($_POST['uploadedFile'])) {
			// Javascript on, so the file has been uploaded and its filename is in the POST array
			// We need to check it and then move it into the hwdVideoShare upload directory
			// Search for file
			if ($handle = opendir(HWDVIDSPATH.'/uploads/flash/files')) {
				$n = 0;
				/* This is the correct way to loop over the directory. */
				while (false !== ($file = readdir($handle))) {
					if (substr($file, 14) == $_POST['uploadedFile']) {
						// echo "FILE NAME MATCH FOUND:$file\n";
						$file_name = $file;
						$n++;
					}
				}
				closedir($handle);

				if ($n < 1) {
					hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_ERROR_UPLDERR00, "exclamation.png", 0);
					return;
				} elseif ($n > 1) {
					hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_ERROR_UPLDERR00, "exclamation.png", 0);
					return;
				} else {
					// single match found so can continue
					$file_ext = substr(strrchr($file_name, '.'), 1);
					$file_video_name = $file_video_id.".".$file_ext;
					$file_video_path = $uploadDir . $file_video_name;

					if (@copy(HWDVIDSPATH."/uploads/flash/files/".$file_name, $file_video_path)) {
						// echo "COPIED FILE FROM TEMP LOCATION INTO hwdVideoShare DIRECTORY\n";
						if (file_exists($file_video_path)) {
							if (!@unlink(HWDVIDSPATH."/uploads/flash/files/".$file_name)) {
								// echo "COULD NOT REMOVE TEMPORARY VIDEO FILE\n";
							}
						}
					} else {
						hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_ERROR_UPLDERR00, "exclamation.png", 0);
						return;
					}
				}
			}
		} else {
			hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_PHPUPLD_ERR00, "exclamation.png", 0);
			return;
		}

		if (file_exists($file_video_path)) {

			$row = new hwdvids_video($db);

			$title 				= Jrequest::getVar( 'title', _HWDVIDS_UNKNOWN, 'request' );
			$description 		= Jrequest::getVar( 'description', _HWDVIDS_UNKNOWN );
			$category_id 		= JRequest::getInt( 'category_id', 0, 'post' );
			$tags 				= Jrequest::getVar( 'tags', _HWDVIDS_UNKNOWN );
			$public_private 	= JRequest::getWord( 'public_private' );
			$allow_comments 	= JRequest::getInt( 'allow_comments', 0, 'post' );
			$allow_embedding 	= JRequest::getInt( 'allow_embedding', 0, 'post' );
			$allow_ratings 		= JRequest::getInt( 'allow_ratings', 0, 'post' );

			$user_id 			= $my->id;

			if ($file_ext == "swf") {
				$_POST['video_type'] 		= "swf";
			} else {
				$_POST['video_type'] 		= "local";
			}

			$_POST['title'] 			= $title;
			$_POST['description'] 		= $description;
			$_POST['category_id'] 		= $category_id;
			$_POST['tags'] 				= $tags;
			$_POST['public_private'] 	= $public_private;
			$_POST['allow_comments'] 	= $allow_comments;
			$_POST['allow_embedding'] 	= $allow_embedding;
			$_POST['allow_ratings'] 	= $allow_ratings;
			$_POST['date_uploaded'] 	= date('Y-m-d H:i:s');
			$_POST['user_id'] 			= $my->id;
			$_POST['published'] 		= 1;

			//check if already exists
			$db->SetQuery( 'SELECT count(*)'
							. ' FROM #__hwdvidsvideos'
							. ' WHERE video_id = "'.$file_video_id.'"'
							);
			$duplicatecount = $db->loadResult();
			if ($duplicatecount > 0) {
        		hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_ERROR_UPLDERR00, "exclamation.png", 0);
				return;
			}

			$checkform = hwd_vs_tools::checkFormComplete($title, $description, $category_id, $tags, $public_private, $allow_comments, $allow_embedding, $allow_ratings);
			if (!$checkform) { return; }

			if ($c->requiredins == 1) {
				// check if we are reprocessing
				if ($c->reconvertflv == 0) {
					if ($file_ext == "flv") {
						$_POST['approved'] = "queuedforthumbnail";
					} else if ($file_ext == "swf") {
						$_POST['approved'] = "queuedforswf";
					} else {
						$_POST['approved'] = "queuedforconversion";
					}
				} else {
					if ($file_ext == "swf") {
						$_POST['approved'] = "queuedforswf";
					} else {
						$_POST['approved'] = "queuedforconversion";
					}
				}
				$_POST['video_id'] = $file_video_name;
			} else if ($c->requiredins == 0) {
				// get new file name
				$originals_Dir = HWDVIDSPATH.'/../../hwdvideos/uploads/originals/';
				$base_Dir = HWDVIDSPATH.'/../../hwdvideos/uploads/';

				if (!copy($originals_Dir.$file_video_name, $base_Dir.$file_video_name)) {
        			hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_ERROR_UPLDERR06, "exclamation.png", 0);
					return;
				} else {
					if ($c->deleteoriginal == 1) {
						if (file_exists($base_Dir.$file_video_name) && file_exists($originals_Dir.$file_video_name)) {
							@unlink($originals_Dir.$file_video_name);
						}
					}
				if ($c->aav == 1) {
					$_POST['approved'] = "yes";
				} else {
					$_POST['approved'] = "pending";
				}
				$_POST['video_id'] = $file_video_id;
				}
			}
			if(empty($_POST['video_id'])) {
				hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_ALERT_ERRUP, "exclamation.png", 0);
				return;
			}

			// bind it to the table
			if (!$row->bind($_POST)) {
				echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
				exit();
			}

			// store it in the db
			if (!$row->store()) {
				echo "<script> alert('".$row -> getError()."'); window.history.go(-1); </script>\n";
				exit();
			}

			// mail admin notification
			if ($c->mailvideonotification == 1) {
				$mailbody = ""._HWDVIDS_MAIL_BODY0.$mosConfig_sitename.".\n";
				$mailbody .= ""._HWDVIDS_MAIL_BODY1."\"".$_POST['title']."\".\n";
				$mailbody .= "".$mosConfig_live_site."/index.php?option=com_hwdvideoshare&Itemid=".$Itemid."&task=viewvideo&video_id=".$row->id."\n";
				$mailbody .= ""._HWDVIDS_MAIL_BODY2."\n";
				$mailbody .= $mosConfig_live_site."/administrator";

				JUtility::sendMail( $mosConfig_mailfrom, $mosConfig_fromname, $c->mailnotifyaddress, _HWDVIDS_MAIL_SUBJECT1.$mosConfig_sitename.' ', $mailbody );
			}

		}

		// send upload to converter if required
		if ($c->requiredins == 1) {
			if ($c->autoconvert == "direct") {
				@exec("env -i $s->phppath ".HWDVIDSPATH."/converters/converter.php &>/dev/null &");
			} else if ($c->autoconvert == "wget") {
				@exec("env -i $s->wgetpath -O - -q ".JURI::root()."components/com_hwdvideoshare/converters/converter.php &>/dev/null &");
			}
		}
		// perform maintenance
		include(HWDVIDSPATH.'/../../administrator/components/com_hwdvideoshare/maintenance/recount.class.php');
		hwd_vs_recount::recountVideosInCategory($row->category_id);
		if (file_exists(HWDVIDSPATH.'/../../administrator/components/com_hwdrevenuemanager/redrawplaylist.class.php')) {
			require_once(HWDVIDSPATH.'/../../administrator/components/com_hwdrevenuemanager/redrawplaylist.class.php');
			hwd_rm_playlist::writeFile($row);
		}

		if ($c->cbint == 2) {
			require_once( JPATH_SITE . DS . 'components' . DS . 'com_community' . DS . 'libraries' . DS . 'core.php' );
			require_once( JPATH_SITE . DS . 'components' . DS . 'com_community' . DS . 'libraries' . DS . 'error.php' );

			$act = new stdClass();
			$act->cmd 	= 'video.upload';
			$act->actor 	= $my->id;
			$act->target 	= 0; // no target
			$act->title 	= JText::_('{actor} has uploaded {single}a new {app} video{/single}{multiple}{count} {app} videos{/multiple}');
			$act->content 	= '';
			$act->app 	= 'hwdvideoshare';
			$act->cid 	= 0;

			CFactory::load('libraries', 'activities');
			CActivityStream::add($act);
		}

		hwd_vs_html::uploadConfirm($option, $title);
	}
    /**
     * Outputs frontpage HTML
     *
     * @param string $option  the joomla component name
     * @param array  $rows  array of video data
     * @param array  $rowsfeatured  array of featured video data
     * @param object $pageNav  page navigation object
     * @param int    $total  the total video count
     * @return       Nothing
     */
    function upldcon1()
	{
	global $database, $my, $acl, $mosConfig_absolute_path, $mosConfig_mailfrom, $mosConfig_fromname, $mosConfig_live_site, $Itemid, $mosConfig_sitename;
	$c = hwd_vs_Config::get_instance();


	}
    /**
     * Outputs frontpage HTML
     *
     * @param string $option  the joomla component name
     * @param array  $rows  array of video data
     * @param array  $rowsfeatured  array of featured video data
     * @param object $pageNav  page navigation object
     * @param int    $total  the total video count
     * @return       Nothing
     */
    function uploadConfirmPhp()
	{
	global $database, $my, $acl, $mosConfig_absolute_path, $mosConfig_mailfrom, $mosConfig_fromname, $mosConfig_live_site, $Itemid, $option, $mosConfig_sitename;
		$c = hwd_vs_Config::get_instance();
		$db = & JFactory::getDBO();
		$my = & JFactory::getUser();
		$acl= & JFactory::getACL();

		// get server configuration data
		require_once(HWDVIDSPATH.'/../../administrator/components/com_hwdvideoshare/serverconfig.hwdvideoshare.php');
		$s = hwd_vs_SConfig::get_instance();

		$file_name0= (isset($_FILES['upfile_0']['tmp_name']) ? $_FILES['upfile_0']['tmp_name'] : "");
		$file_name = (isset($_FILES['upfile_0']['name']) ? $_FILES['upfile_0']['name'] : "");
		$file_size = (isset($_FILES['upfile_0']['size']) ? $_FILES['upfile_0']['size'] : "");

		if (!isset($_FILES['upfile_0']['error'])) {
        	hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_PHPUPLD_ERR00, "exclamation.png", 0);
			return;
		} else if ($_FILES['upfile_0']['error'] == 8) {
        	hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_PHPUPLD_ERR08, "exclamation.png", 0);
			return;
		} else if ($_FILES['upfile_0']['error'] == 7) {
        	hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_PHPUPLD_ERR07, "exclamation.png", 0);
			return;
		} else if ($_FILES['upfile_0']['error'] == 6) {
        	hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_PHPUPLD_ERR06, "exclamation.png", 0);
			return;
		} else if ($_FILES['upfile_0']['error'] == 5) {
        	hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_PHPUPLD_ERR05, "exclamation.png", 0);
			return;
		} else if ($_FILES['upfile_0']['error'] == 4) {
        	hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_PHPUPLD_ERR04, "exclamation.png", 0);
			return;
		} else if ($_FILES['upfile_0']['error'] == 3) {
        	hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_PHPUPLD_ERR03, "exclamation.png", 0);
			return;
		} else if ($_FILES['upfile_0']['error'] == 2) {
        	hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_PHPUPLD_ERR02, "exclamation.png", 0);
			return;
		} else if ($_FILES['upfile_0']['error'] == 1) {
        	hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_PHPUPLD_ERR01, "exclamation.png", 0);
			return;
		} else if ($_FILES['upfile_0']['error'] == 0) {

			$title 				= Jrequest::getVar( 'title', _HWDVIDS_UNKNOWN, 'request' );
			$description 		= Jrequest::getVar( 'description', _HWDVIDS_UNKNOWN );
			$category_id 		= JRequest::getInt( 'category_id', 0, 'post' );
			$tags 				= Jrequest::getVar( 'tags', _HWDVIDS_UNKNOWN );
			$public_private 	= JRequest::getWord( 'public_private' );
			$allow_comments 	= JRequest::getInt( 'allow_comments', 0, 'post' );
			$allow_embedding 	= JRequest::getInt( 'allow_embedding', 0, 'post' );
			$allow_ratings 		= JRequest::getInt( 'allow_ratings', 0, 'post' );

			$checkform = hwd_vs_tools::checkFormComplete($title, $description, $category_id, $tags, $public_private, $allow_comments, $allow_embedding, $allow_ratings);
			if (!$checkform) { return; }

			$row = new hwdvids_video($db);

			if (!empty($file_name)) {
				// generate random filename
				$file_video_id = hwd_vs_tools::generateNewVideoid();
				// get extension and create new random filename
				$file_ext = substr($file_name, strrpos($file_name, '.') + 1);
				$file_video_name = $file_video_id.".".$file_ext;
			}

			if (empty($file_video_name)) {
        		hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_ERROR_UPLDERR00, "exclamation.png", 0);
				return;
			}

			$sizelimit = $c->maxupld*1024*1024; //size limit in mb
			if ($file_size > $sizelimit) {
        		hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_ERROR_UPLDERR02." ".$c->maxupld."MB.", "exclamation.png", 0);
				return;
			}

			$filename = split("\.", $file_video_name);
			if (eregi("[^0-9a-zA-Z_]", $filename[0])) {
        		hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_ERROR_UPLDERR03, "exclamation.png", 0);
				return;
			}

			if ($c->requiredins == 1) {
				$_POST['video_id'] = $file_video_name;

				$oformats = explode(",", $c->oformats);
				// check file extensions
				if (($c->ft_mpg == "on" && $file_ext == "mpg") || ($c->ft_mpeg == "on" && $file_ext == "mpeg") || ($c->ft_avi == "on" && $file_ext == "avi") || ($c->ft_divx == "on" && $file_ext == "divx") || ($c->ft_mp4 == "on" && $file_ext == "mp4") || ($c->ft_flv == "on" && $file_ext == "flv") || ($c->ft_wmv == "on" && $file_ext == "wmv") || ($c->ft_rm == "on" && $file_ext == "rm") || ($c->ft_mov == "on" && $file_ext == "mov") || ($c->ft_moov == "on" && $file_ext == "moov") || ($c->ft_asf == "on" && $file_ext == "asf") || ($c->ft_swf == "on" && $file_ext == "swf") || ($c->ft_vob == "on" && $file_ext == "vob")) {
					// format matches a main allowed format
				} else if (in_array($file_ext, $oformats )) {
					// format matches an allowed extra format
				} else {
        			hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_ERROR_UPLDERR04, "exclamation.png", 0);
					return;
				}
				// move to uploaded file directory
				$base_Dir = HWDVIDSPATH.'/../../hwdvideos/uploads/originals/';
				if (file_exists($base_Dir.$file_video_name)) {
        			hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_ERROR_UPLDERR05, "exclamation.png", 0);
					return;
				}
				if (!move_uploaded_file ($_FILES['upfile_0']['tmp_name'],$base_Dir.$file_video_name)) {
        			hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_ERROR_UPLDERR06, "exclamation.png", 0);
					return;
				}

				// check if we are reprocessing
				if ($c->reconvertflv == 0) {
					if ($file_ext == "flv") {
						$_POST['approved'] = "queuedforthumbnail";
					} else if ($file_ext == "swf") {
						$_POST['approved'] = "queuedforswf";
					} else {
						$_POST['approved'] = "queuedforconversion";
					}
				} else {
					if ($file_ext == "swf") {
						$_POST['approved'] = "queuedforswf";
					} else {
						$_POST['approved'] = "queuedforconversion";
					}
				}
			} else if ($c->requiredins == 0) {
				$_POST['video_id'] = $file_video_id;
				if ($file_ext !== "flv") {
        			hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_ERROR_UPLDERR04, "exclamation.png", 0);
					return;
				}
				$base_Dir = HWDVIDSPATH.'/../../hwdvideos/uploads/';
				if (file_exists($base_Dir.$file_video_name)) {
        			hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_ERROR_UPLDERR05, "exclamation.png", 0);
					return;
				}
				if (!move_uploaded_file ($_FILES['upfile_0']['tmp_name'],$base_Dir.$file_video_name) || !JPath::setPermissions($base_Dir.$file_video_name)) {
        			hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_ERROR_UPLDERR06, "exclamation.png", 0);
					return;
				}
				if ($c->aav == 1) {
					$_POST['approved'] = "yes";
				} else {
					$_POST['approved'] = "pending";
				}
			}

			//check if already exists
			$db->SetQuery( 'SELECT count(*)'
							. ' FROM #__hwdvidsvideos'
							. ' WHERE video_id = "'.$file_video_id.'"'
							);
			$duplicatecount = $db->loadResult();
			if ($duplicatecount > 0) {
        		hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_ALERT_DUPLICATE, "exclamation.png", 0);
				return;
			}

			$ext = strrchr($file_name, '.');
			if ($ext == ".swf") {
				$_POST['video_type'] 		= "swf";
			} else {
				$_POST['video_type'] 		= "local";
			}

			$_POST['title'] 			= $title;
			$_POST['description'] 		= $description;
			$_POST['category_id'] 		= $category_id;
			$_POST['tags'] 				= $tags;
			$_POST['public_private'] 	= $public_private;
			$_POST['allow_comments'] 	= $allow_comments;
			$_POST['allow_embedding'] 	= $allow_embedding;
			$_POST['allow_ratings'] 	= $allow_ratings;
			$_POST['date_uploaded'] 	= date('Y-m-d H:i:s');
			$_POST['user_id'] 			= $my->id;
			$_POST['published'] 		= "1";

			if(empty($_POST['video_id'])) {
        		hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_ERROR_UPLDERR00, "exclamation.png", 0);
				return;
			}

			// bind it to the table
			if (!$row->bind($_POST)) {
				echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
				exit();
			}

			// store it in the db
			if (!$row->store()) {
				echo "<script> alert('".$row -> getError()."'); window.history.go(-1); </script>\n";
				exit();
			}

			// mail admin notification
			if ($c->mailvideonotification == 1) {
				$mailbody = ""._HWDVIDS_MAIL_BODY0.$mosConfig_sitename.".\n";
				$mailbody .= ""._HWDVIDS_MAIL_BODY1."\"".$_POST['title']."\".\n";
				$mailbody .= "".$mosConfig_live_site."/index.php?option=com_hwdvideoshare&Itemid=".$Itemid."&task=viewvideo&video_id=".$row->id."\n";
				$mailbody .= ""._HWDVIDS_MAIL_BODY2."\n";
				$mailbody .= $mosConfig_live_site."/administrator";

				JUtility::sendMail( $mosConfig_mailfrom, $mosConfig_fromname, $c->mailnotifyaddress, _HWDVIDS_MAIL_SUBJECT1.$mosConfig_sitename.' ', $mailbody );
			}
		}

		// send upload to converter if required
		if ($c->requiredins == 1) {
			if ($c->autoconvert == "direct") {
				@exec("env -i $s->phppath ".HWDVIDSPATH."/converters/converter.php &>/dev/null &");
			} else if ($c->autoconvert == "wget") {
				@exec("env -i $s->wgetpath -O - -q ".JURI::root()."components/com_hwdvideoshare/converters/converter.php &>/dev/null &");
			}
		}
		// perform maintenance
		include(HWDVIDSPATH.'/../../administrator/components/com_hwdvideoshare/maintenance/recount.class.php');
		hwd_vs_recount::recountVideosInCategory($row->category_id);
		if (file_exists(HWDVIDSPATH.'/../../administrator/components/com_hwdrevenuemanager/redrawplaylist.class.php')) {
			require_once(HWDVIDSPATH.'/../../administrator/components/com_hwdrevenuemanager/redrawplaylist.class.php');
			hwd_rm_playlist::writeFile($row);
		}

		if ($c->cbint == 2) {
			require_once( JPATH_SITE . DS . 'components' . DS . 'com_community' . DS . 'libraries' . DS . 'core.php' );
			require_once( JPATH_SITE . DS . 'components' . DS . 'com_community' . DS . 'libraries' . DS . 'error.php' );

			$act = new stdClass();
			$act->cmd 	= 'video.upload';
			$act->actor 	= $my->id;
			$act->target 	= 0; // no target
			$act->title 	= JText::_('{actor} has uploaded {single}a new {app} video{/single}{multiple}{count} {app} videos{/multiple}');
			$act->content 	= '';
			$act->app 	= 'hwdvideoshare';
			$act->cid 	= 0;

			CFactory::load('libraries', 'activities');
			CActivityStream::add($act);
		}

		hwd_vs_html::uploadConfirm($option, $title);
	}
    /**
     * Outputs frontpage HTML
     *
     * @param string $option  the joomla component name
     * @param array  $rows  array of video data
     * @param array  $rowsfeatured  array of featured video data
     * @param object $pageNav  page navigation object
     * @param int    $total  the total video count
     * @return       Nothing
     */
    function uploadMedia($option)
	{
		global $database, $mosConfig_live_site, $mosConfig_allowUserRegistration, $Itemid;
		$c = hwd_vs_Config::get_instance();
		$db = & JFactory::getDBO();
		$my = & JFactory::getUser();
		$acl= & JFactory::getACL();
		$usersConfig = &JComponentHelper::getParams( 'com_users' );

		$sessid = session_id();
		if (empty($sessid)) {
			session_start();
		}
		// check access settings and deny those without privileges
		if ($c->access_method == 0) {
			if (!hwd_vs_access::allowAccess( $c->gtree_upld, $c->gtree_upld_child, hwd_vs_access::userGID( $my->id ))) {
				if ( ($my->id < 1) && (!$usersConfig->get( 'allowUserRegistration' ) == '0' && hwd_vs_access::allowAccess( $c->gtree_upld, 'RECURSE', $acl->get_group_id('Registered','ARO') ) ) ) {
					hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_NOACCESS, _HWDVIDS_ALERT_REGISTERFORUPLD, "exclamation.png", 0);
					return;
				} else {
					hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_NOACCESS, _HWDVIDS_ALERT_UPLD_NOT_AUTHORIZED, "exclamation.png", 0);
					return;
				}
			}
		} else if ($c->access_method == 1) {
			if (!hwd_vs_access::allowLevelAccess( $c->accesslevel_upld, hwd_vs_access::userGID( $my->id ))) {
				hwd_vs_tools::infomessage(1, 0,  _HWDVIDS_TITLE_NOACCESS, _HWDVIDS_ALERT_NOT_AUTHORIZED, "exclamation.png", 0);
				return;
			}
		}

		$videotype = JRequest::getCmd( 'videotype' );

		// check for any published third party video site plugins
		$db->SetQuery( 'SELECT count(*)'
						. ' FROM #__hwdvidsplugin'
						. ' WHERE published = 1'
						. ' AND type = "thirdparty"'
						);
  		$thirdpartycount = $db->loadResult();
		echo $db->getErrorMsg();

		$checksecurity = "0";
		if ( (empty($videotype)) && ($thirdpartycount > 0) && ($c->disablelocupld == 0) ) {
			$uploadpage = "0";
		} else if ( (empty($videotype)) && (!$thirdpartycount || $thirdpartycount == 0) && ($c->disablelocupld == 0) ) {
			$uploadpage = "1";
		} else if ( (empty($videotype)) && ($thirdpartycount > 0) && ($c->disablelocupld == 1)) {
			$uploadpage = "thirdparty";
		} else if ( (empty($videotype)) && (!$thirdpartycount || $thirdpartycount == 0) && ($c->disablelocupld == 1)) {
        	hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_ALERT_NOUPLDMETH, "exclamation.png", 0);
			return;
		} else if ($videotype == "00") {
			$uploadpage = "1";
		} else if ($videotype == "local") {
			$uploadpage = "2";
			$checksecurity = "1";
		} else {
			$uploadpage = "thirdparty";
		}

		$title 				= Jrequest::getVar( 'title', 'no name supplied' );
		$description 		= Jrequest::getVar( 'description', 'no name supplied' );
		$category_id 		= JRequest::getInt( 'category_id', 0, 'post' );
		$tags 				= Jrequest::getVar( 'tags', 'no name supplied' );
		$public_private 	= JRequest::getWord( 'public_private' );
		$allow_comments 	= JRequest::getInt( 'allow_comments', 0 );
		$allow_embedding 	= JRequest::getInt( 'allow_embedding', 0 );
		$allow_ratings 		= JRequest::getInt( 'allow_ratings', 0 );

		$security_code = JRequest::getCmd( 'security_code' );

		if ($c->disablecaptcha == "1") {
			$checksecurity = "0";
		}

		if ($checksecurity == "1") {
			if(($_SESSION['security_code'] == $security_code) && (!empty($_SESSION['security_code'])) ) {
					// Insert you code for processing the form here, e.g emailing the submission, entering it into a database.
					hwd_vs_html::uploadmedia($option, $uploadpage, $videotype, $checksecurity, $title, $description, $category_id, $tags, $public_private, $allow_comments, $allow_embedding, $allow_ratings);
					unset($_SESSION['security_code']);
			} else {
				// Insert your code for showing an error message here
        		hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_ALERT_ERRSC, "exclamation.png", 0);
				return;
			}
		} else {
			hwd_vs_html::uploadMedia($option, $uploadpage, $videotype, $checksecurity, $title, $description, $category_id, $tags, $public_private, $allow_comments, $allow_embedding, $allow_ratings);
		}
	}
    /**
     * Outputs frontpage HTML
     *
     * @param string $option  the joomla component name
     * @param array  $rows  array of video data
     * @param array  $rowsfeatured  array of featured video data
     * @param object $pageNav  page navigation object
     * @param int    $total  the total video count
     * @return       Nothing
     */
    function addConfirm($option)
	{
		global $my, $acl, $mosConfig_mailfrom, $mosConfig_fromname, $mosConfig_live_site, $Itemid, $mosConfig_sitename;
		$c = hwd_vs_Config::get_instance();
		$db = & JFactory::getDBO();
		$my = & JFactory::getUser();
		$acl= & JFactory::getACL();

		$requestarray = JRequest::get( 'default', 2 );
		$embeddump = $requestarray['embeddump'];

		$parsedurl = parse_url($embeddump);
		preg_match('/(?P<domain>[a-z0-9][a-z0-9\-]{1,63}\.[a-z\.]{2,6})$/i', $parsedurl['host'], $regs);

		if ($regs['domain'] == "youtube.com") {
			require_once(HWDVIDSPATH.'/core/youtube/youtube.php');
		} else if ($regs['domain'] == "google.com") {
			require_once(HWDVIDSPATH.'/core/google/google.php');
		} else if (file_exists(HWDVIDSPATH.'/../../hwdvideos/plugin/thirdparty/thirdpartysupportpack/'.$regs['domain'].'/'.$regs['domain'].'.php')) {
			require_once(HWDVIDSPATH.'/../../hwdvideos/plugin/thirdparty/thirdpartysupportpack/'.$regs['domain'].'/'.$regs['domain'].'.php');
		} else {
			$error_msg = _HWDVIDS_ERROR_UPLDERR11."<br /><br />"._HWDVIDS_INFO_SUPPTPW."<br />".hwd_vs_tools::generateSupportedWebsiteList();
         	hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, $error_msg, "exclamation.png", 1);
			return;
		}

		$ext_v_code  = hwd_vs_tp::processcode($embeddump);
		$ext_v_title = hwd_vs_tp::processtitle($embeddump);
		$ext_v_descr = hwd_vs_tp::processdescr($embeddump);
		$ext_v_keywo = hwd_vs_tp::processkeywo($embeddump);
		$ext_v_durat = hwd_vs_tp::processdurat($embeddump);

		if ($ext_v_code[0] == "0") {
        	hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_INFO_TPPROCESSFAIL, "exclamation.png", 0);
			return;
		}

		$failures = "";
		if ($ext_v_title[0] == 0) {$failures.=_HWDVIDS_INFO_TPTITLEFAIL."<br />";}
		if ($ext_v_descr[0] == 0) {$failures.=_HWDVIDS_INFO_TPDESCFAIL."<br />";}
		if ($ext_v_keywo[0] == 0) {$failures.=_HWDVIDS_INFO_TPKWFAIL."<br />";}
		if ($ext_v_durat[0] == 0) {$failures.=_HWDVIDS_INFO_TPDRFAIL."<br />";}

		//check if already exists
		$db->SetQuery( 'SELECT count(*)'
						. ' FROM #__hwdvidsvideos'
						. ' WHERE video_id = "'.$ext_v_code.'"'
						);
		$duplicatecount = $db->loadResult();
		if ($duplicatecount > 0) {
        	hwd_vs_tools::infomessage(4, 0, _HWDVIDS_TITLE_UPLDFAIL, _HWDVIDS_ALERT_DUPLICATE, "exclamation.png", 0);
			return;
		}

		$title = $ext_v_title[1];
		$description = $ext_v_descr[1];
		$category_id = JRequest::getInt( 'category_id', 0, 'post' );
		$tags = $ext_v_keywo[1];
		$public_private = JRequest::getWord( 'public_private' );
		$allow_comments = JRequest::getInt( 'allow_comments', 0, 'post' );
		$allow_embedding = JRequest::getInt( 'allow_embedding', 0, 'post' );
		$allow_ratings = JRequest::getInt( 'allow_ratings', 0, 'post' );

		$checkform = hwd_vs_tools::checkFormComplete($title, $description, $category_id, $tags, $public_private, $allow_comments, $allow_embedding, $allow_ratings);
		if (!$checkform) { return; }

		$row = new hwdvids_video($db);

		$_POST['video_type'] 		= $regs['domain'];
		$_POST['video_id'] 			= $ext_v_code[1];
		$_POST['title'] 			= $title;
		$_POST['description'] 		= $description;
		$_POST['category_id'] 		= $category_id;
		$_POST['tags'] 				= $tags;
		$_POST['public_private'] 	= $public_private;
		$_POST['allow_comments'] 	= $allow_comments;
		$_POST['allow_embedding'] 	= $allow_embedding;
		$_POST['allow_ratings'] 	= $allow_ratings;
		$_POST['video_length'] 		= $ext_v_durat[1];
		$_POST['date_uploaded'] 	= date('Y-m-d H:i:s');
		$_POST['user_id'] 			= $my->id;

		if ($c->aa3v == 1) {
			$_POST['approved'] 	= "yes";
			$_POST['published'] = "1";
		} else {
			$_POST['approved'] 	= "pending";
			$_POST['published'] = "0";
		}

		// bind it to the table
		if (!$row->bind($_POST)) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		// store it in the db
		if (!$row->store()) {
			echo "<script> alert('".$row -> getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		// mail admin notification
		if ($c->mailvideonotification == 1) {
			$mailbody = ""._HWDVIDS_MAIL_BODY0.$mosConfig_sitename.".\n";
			$mailbody .= ""._HWDVIDS_MAIL_BODY1."\"".$_POST['title']."\".\n";
			$mailbody .= "".$mosConfig_live_site."/index.php?option=com_hwdvideoshare&Itemid=".$Itemid."&task=viewvideo&video_id=".$row->id."\n";
			$mailbody .= ""._HWDVIDS_MAIL_BODY2."\n";
			$mailbody .= $mosConfig_live_site."/administrator";

			JUtility::sendMail( $mosConfig_mailfrom, $mosConfig_fromname, $c->mailnotifyaddress, _HWDVIDS_MAIL_SUBJECT1.$mosConfig_sitename.' ', $mailbody );
		}

		// perform maintenance
		include(HWDVIDSPATH.'/../../administrator/components/com_hwdvideoshare/maintenance/recount.class.php');
		hwd_vs_recount::recountVideosInCategory($row->category_id);

		if ($c->cbint == 2) {
			require_once( JPATH_SITE . DS . 'components' . DS . 'com_community' . DS . 'libraries' . DS . 'core.php' );
			require_once( JPATH_SITE . DS . 'components' . DS . 'com_community' . DS . 'libraries' . DS . 'error.php' );

			$act = new stdClass();
			$act->cmd 	= 'video.upload';
			$act->actor 	= $my->id;
			$act->target 	= 0; // no target
			$act->title 	= JText::_('{actor} has uploaded {single}a new {app} video{/single}{multiple}{count} {app} videos{/multiple}');
			$act->content 	= '';
			$act->app 	= 'hwdvideoshare';
			$act->cid 	= 0;

			CFactory::load('libraries', 'activities');
			CActivityStream::add($act);
		}

		hwd_vs_html::addConfirm($option, $title, $failures, $row);
	}

}
?>