<?php
/**
 * @version 2.0.1
 * @package moseasymedia
 * @copyright Copyright &copy; 2008, Brilaps LLC
 * @author Ozgur Cem Sen
 * @email code@brilaps.com
 * @link http://brilaps.com || http://wiki.brilaps.com
 * @license http://www.opensource.org/licenses/gpl-license.php GNU/GPL v.2 .
 */


/**
 * replica of database::getEscaped in Mambo CMS project
 *
 */
class cmoseasymediaEmbed {

	/**
	 * Player name
	 *
	 * @var String
	 */
	var $player = "";

	/**
	 * File path/url
	 *
	 * @var String
	 */
	var $mediaPath = "";

	/**
	 * Params
	 *
	 * @var Object
	 */
	var $moseasymediaparams = "";


	/**
	 * Unique ID for the player to be set in session - for popup security
	 *
	 * @var string
	 */
	var $uniqueID = "";

	/**
	 * Unique div ID for div encapsulating the player
	 *
	 * @var unknown_type
	 */
	var $div_id = "";


	/**
	 * Output string
	 *
	 * @var String
	 */
	var $embedString = "";


	/**
	 * Constructor for base embed class. All other players' classes are derived from this
	 *
	 * @param String $player
	 * @param String $mediaPath
	 * @param String $moseasymediaparams
	 * @return cmoseasymediaEmbed
	 */
	function cmoseasymediaEmbed($player, $mediaPath, $moseasymediaparams) {
		$this->player = $player;
		$this->mediaPath =  $mediaPath;
		$this->moseasymediaparams = $moseasymediaparams;

		$this->uniqueID = 'ocs'.$this->player.rand();
		$this->div_id = 'moseasymedia'.$this->player.$this->uniqueID;
	}

	function getHeader () {

		global $MOSEASYMEDIA_BASE_URL;
		global $JSANDCSS;
		$embedString = '<!-- moseasymedia generated embed code, by Brilaps, (c) 2008-->' ;
		$css = '<link  href="'.$MOSEASYMEDIA_BASE_URL.'css/'.$this->moseasymediaparams->get("ocsmem_CSS$this->player", "moseasymedia$this->player.css").'" rel="stylesheet" type="text/css" media="screen" />';
		if (!in_array($css, $JSANDCSS)) { 
		  array_push($JSANDCSS, $css);
		  echo $css;
		}
		$embedString .= '<div class="moseasymedia'.$this->player.'" id="'.$this->div_id.'">';
		return $embedString;
	}

	function getFooter () {

		$embedString = '</div>';
		$embedString .= '<!-- moseasymedia -->' ;
		return $embedString;
	}

	function getThumbnail() {

		$mediathumbnail = $this->moseasymediaparams->get("ocsmem_Popup_popupmediathumbnail", "none");
		if ($mediathumbnail !== "none") {
			$mediathumbnail = "<img src='$mediathumbnail' alt='click on the link below to play the media' title='click on the link below to play the media'/><br/>";
		}
		else
		$mediathumbnail = "";
			
		return $mediathumbnail;
	}

	function popupCode ($embedCode) {

		global $MOSEASYMEDIA_BASE_URL;
		$pop = "";
		$popupStyle = $this->moseasymediaparams->get("ocsmem_Popup_popup", "none");
		$url = $MOSEASYMEDIA_BASE_URL."embed.php?embed=".$this->uniqueID  ;
		if ($popupStyle == "window") {
			session_name("moseasymedia");
			if (!isset($_SESSION)) session_start();
			session_register($this->uniqueID);
			$_SESSION[$this->uniqueID] = $embedCode;
			$url .= '&sess='.session_id();
			$url .= '&div='.$this->div_id;
			

			$pop .= "<p><a title=\"click on the link below to play the media\" class=\"moseasmedia-popup-link\" href=\"javascript:void window.open(";
			$pop .= "'".$url."', ";
			$pop .= "'".$this->uniqueID."', ";
			$pop .= "'toolbar=".$this->moseasymediaparams->get("ocsmem_Popup_popuptoolbar").",";
			$pop .= "location=".$this->moseasymediaparams->get("ocsmem_Popup_popuplocation").",";
			$pop .= "scrollbars=".$this->moseasymediaparams->get("ocsmem_Popup_popupscrollbars").",";
			$pop .= "menubar=".$this->moseasymediaparams->get("ocsmem_Popup_popupmenubar").",";
			$pop .= "width=".$this->moseasymediaparams->get("ocsmem_Popup_popupwidth").",";
			$pop .= "height=".$this->moseasymediaparams->get("ocsmem_Popup_popupheight")."'";
			$pop .= ");\"";
			$pop .= ">".$this->getThumbnail().strip_tags($this->moseasymediaparams->get("ocsmem_Popup_popuplinktext"))."</a></p>";

		}
		else if ($popupStyle == "thickbox") {
			
			session_name("moseasymedia");
			if (!isset($_SESSION)) session_start();
			session_register($this->uniqueID);
			$_SESSION[$this->uniqueID] = $embedCode;
			$url .= '&sess='.session_id();
			$url .= '&div='.$this->div_id;
			
			if ($this->moseasymediaparams->get("ocsmem_Popup_ThickboxExists") != "yes") {
				
			    global $JSANDCSS; 
				$css = '<link  href="'.$MOSEASYMEDIA_BASE_URL.'js/thickbox.css" rel="stylesheet" type="text/css" media="screen" />';
				if (!in_array($css, $JSANDCSS)) { 
		           array_push($JSANDCSS, $css);
		           echo $css;
		        }
				$js = '<script src="'.$MOSEASYMEDIA_BASE_URL.'js/jquery.js" type="text/javascript"></script>';
			    if (!in_array($js, $JSANDCSS)) { 
	                array_push($JSANDCSS, $js);
	                echo $js;
	            }
				$js = '<script src="'.$MOSEASYMEDIA_BASE_URL.'js/thickbox.js" type="text/javascript"></script>';
			    if (!in_array($js, $JSANDCSS)) { 
	                array_push($JSANDCSS, $js);
	                echo $js;
	            }         
			}
			
			$pop .= '<p><a href="'.$url.'&KeepThis=true&TB_iframe=true';
			$pop .= '&width='.$this->moseasymediaparams->get("ocsmem_Popup_popupwidth");
			$pop .= '&height='.$this->moseasymediaparams->get("ocsmem_Popup_popupheight");
			$pop .= '&Title=Media" class="thickbox" ';
			$pop .= 'id="'.$this->uniqueID.'"';
			$pop .= ">".$this->getThumbnail().strip_tags($this->moseasymediaparams->get("ocsmem_Popup_popuplinktext"))."</a></p>";
		}

		return $pop;
	}


	/**
	 * Get a database escaped string
	 * @return string
	 */
	function getEscaped( $text ) {
		if (phpversion() < '4.3.0') {
			return mysql_escape_string( $text );
		} else {
			return mysql_real_escape_string( $text );
		}
	}
}

?>