<?php
/**
 * @version 2.0.1
 * @package moseasymedia
 * @copyright Copyright &copy; 2008, Brilaps LLC
 * @author Ozgur Cem Sen
 * @email code@brilaps.com
 * @link http://brilaps.com || http://wiki.brilaps.com
 * @license http://www.opensource.org/licenses/gpl-license.php GNU/GPL v.2 .
 */

/**
 * A trimmed down version on class mosParameters in core.classes.php in Mambo CMS project
 * The entry point of the moseasymedia utilizer application will populate the param array,so that
 * this array can be used generically across moseasymedia
 * A simple key => value pair getter/setter class
 */
class moseasymediaParams {

	/** @var object */
	var $_params = Array();


    /**
     * Sets the parameters.. parser code sets this key => value array 
     * @return string parsed result
     */
    function setParams ($params) {
        foreach ($params as $key=>$value) {
			$this->_params[$key] = $value;
        }
    }
    
    /**
	 * Get the result of parsing the string provided on creation
	 * @return string parsed result
	 */
	function getParams () {
		return $this->_params;
	}
	/**
	 * @param string The name of the param
	 * @param string The value of the parameter
	 * @return string The set value
	 */
	function set( $key, $value='' ) {
		$this->_params[$key] = $value;
		return $value;
	}
	/**
	 * Sets a default value if not alreay assigned
	 * @param string The name of the param
	 * @param string The value of the parameter
	 * @return string The set value
	 */
	function def( $key, $value='' ) {
		return $this->set( $key, $this->get( $key, $value ) );
	}
	/**
	 * @param string The name of the param
	 * @param mixed The default value if not found
	 * @return string
	 */
	function get( $key, $default='' ) {
		if (isset( $this->_params[$key] )) return $this->_params[$key] === '' ? $default : $this->_params[$key];
		else return $default;
	}
}

?>